#ifndef __DyUtil_ph__
#define __DyUtil_ph__

#ifdef __cplusplus
extern "C" {
#endif

void DySoundFillHeader (struct soundhdr *hdr, long srate, long nBytes, short bits_per_sample);
void DySoundReadHeader  (char *buffer);
int DySerDataGet (FrameH *frame, char *name, char **sername, char **param, double *result);
long DyGrafIni  (long reset);
double DyTimeFormatToGps  (const char *timeformat);
char *DyGpsToTimeString  (double origin, struct FrameH *frame, double deltat, int nAverage, char *title);
time_t DyConvertToUTC  (int gps, int uLeapS);
double DyGetStartTime ();
int DyQuitAtClose (FL_FORM *flForm, void *data);
int DyAtClose (FL_FORM *flForm, void *data);
void DyIni  (char **argv, int argc);
void DyRaz  (long arg, long nplot);
void DyMakeTypeNames  ();
void DyFirstLast  (double framePeriod);
void DyStart  (long nPlot);
void DyReadingFrames  ();
void DyPlotFrames  ();
void DyPause  ();
void DyContinue  ();
void DyNext  (long arg);
void DyStop ();
void DySiestaLike  (char *carfile);
void DyInteractionSim  (void *iFile, long time);
int DyCheckRunning  ();
void DyXformQuit  (FL_OBJECT *obj, long arg);
void quitHandler  (int arg);
void DyFree  ();
char *my_strcpy  (char *dummy, char *str);
long max  (long a, long b);
double return_val  (struct FrAdcData *adc, long i);
void DyGetMinMax  (struct FrVect *vect, double *vmin, double *vmax);
void DyGetMinMaxFromTrend  (struct FrameH *frame, char *adcName, double *vmin, double *vmax);
void DyXformPadsConfig  (FL_OBJECT *obj, long arg);
void DyXformChecks  (FL_OBJECT *obj, long arg);
void DyCheckPlot  (long id);
int DyGTimeFromDate  (char *inputDate)   /* inputDate in UTC, output is GTimeS */;
int DyJulianDay (int y, int m, int d);
int DyMissingFrames  (int previous, struct FrameH *frame);
double DyGetMin  (double x1, double x2);
double DyGetMax  (double x1, double x2);
double DyDebugTime ();
char *DyDebugTimeStr  (char *name, int printflag);
double DyDebugTimeNeeded  (const char *fctname, char *flag, int level);
void DyDebugPrint  (const char *msg, int printflag);
int DyCheckMemory ();
char *DyCheckString  (char* name);
char *DyFilterString  (char* name, unsigned char separator);
int DyCountChannels  (struct FrameH *frame);

#ifdef __cplusplus
}
#endif

#endif

