/* ****************************************************************
******* UArrayL.h *************************** UArrayL.h ***********
******* UArrayL.h *************************** UArrayL.h ***********
**************************************************************** */
/* By B.Caron, F.Marion, B.Mours (ESIA/LAPP Annecy) September 14, 1998 */

#if !defined(UARRAYLIB_DEFINED)
#define UARRAYLIB_DEFINED DONE

#include "FrameL.h"
#include "UJobL.h"
#include "USignalL.h"

extern struct UJstructH *UArrayFillFUJstructH;
extern struct UJstructH *UArrayFillDUJstructH;

#define FrVectCD FrVect
#define FrVectD FrVect
#define FrVectCF FrVect
#define FrVectF FrVect

#define UArrayCD FrVectCD
#define UArrayCF FrVectCF
#define UArrayD FrVectD
#define UArrayF FrVectF

struct UArrayFillD{         /* fill a vector with a signal            */
  char *name;               /* name for each instance                 */
  long iClock;              /* clock number                           */
  long nData;               /* vector size                            */
  struct USignal *input;    /* input signal                           */
                            /* ------ end_of_SIO parameters ----------*/
  struct UArrayD *vect;     /* output vector                          */
};

struct UArrayFillF{         /* fill a vector with a signal            */
  char *name;               /* name for each instance                 */
  long iClock;              /* clock number                           */
  long nData;               /* vector size                            */
  struct USignal *input;    /* input signal                           */
                            /* ------ end_of_SIO parameters ----------*/
  struct UArrayF *vect;     /* output vector                          */
};

#define FrVectCDFree(mat) FrVectFree(mat);
#define FrVectDFree(mat) FrVectFree(mat);
#define FrVectCFFree(mat) FrVectFree(mat);
#define FrVectFFree(mat) FrVectFree(mat);

#define FrVectCDNew(nL,nC) FrVectNew(FR_VECT_C16,2,nL,0.,NULL,nC,0.,NULL);
#define FrVectDNew(nL,nC) FrVectNew(FR_VECT_8R,2,nL,0.,NULL,nC,0.,NULL);
#define FrVectCFNew(nL,nC) FrVectNew(FR_VECT_C8,2,nL,0.,NULL,nC,0.,NULL);
#define FrVectFNew(nL,nC) FrVectNew(FR_VECT_4R,2,nL,0.,NULL,nC,0.,NULL);

void UALibIni(void);
/*----------------------------------------------------------------------*/
void UACDAdd(struct UArrayCD *mat1, struct UArrayCD *mat2, 
             struct UArrayCD *matOut);
void UACDCopy(struct UArrayCD *In, struct UArrayCD *Out);
void UACDCscal(struct UArrayCD *in, double c_factor[2], struct UArrayCD *out);
double UACDEcartV(struct UArrayCD *Vect1,struct UArrayCD *Vect2);
void UACDeqn(struct UArrayCD *va,struct UArrayCD *vx,struct UArrayCD *vb);
void UACDfact(struct UArrayCD *va,long *ir);
void UACDfeqn(struct UArrayCD *va,struct UArrayCD *vb,long *ir);
void UACDinv(struct UArrayCD *vIn,struct UArrayCD *vOut);
void UACDfinv(struct UArrayCD *vIn,long *ir);
#define UACDFree(mat) FrVectCDFree(mat);
void UACDft2d(struct UArrayCD *Vect,long msign);
void UACDfft(struct UArrayCD *Vect,long msign);
void UACDinvertV(struct UArrayCD *VectIn, struct UArrayCD *VectOut);
#define UACDNew(nL,nC) FrVectCDNew(nL,nC);
void UACDNormalV(struct UArrayCD *Vect, double xnnorm);
void UACDProd(struct UArrayCD *mat1, struct UArrayCD *mat2, 
              struct UArrayCD *matOut);
void UACDProdSq(struct UArrayCD *Vect1, struct UArrayCD *Vect2, 
                struct UArrayCD *VectOut);
void UACDProdV(struct UArrayCD *mat1, struct UArrayCD *mat2, 
               struct UArrayCD *matOut);
void UACDRscal(struct UArrayCD *in, double factor, struct UArrayCD *out);
void UACDScalV(struct UArrayCD *Vect1, struct UArrayCD *Vect2, double ps[2]);
void UACDSolve3V(struct UArrayCD *va,struct UArrayCD *vx,struct UArrayCD *vb);
void UACDSub(struct UArrayCD *mat1,struct UArrayCD *mat2, 
             struct UArrayCD *matOut);
void UACDsymLines(struct UArrayCD *matIn,struct UArrayCD *matOut);
void UACDunitSub(struct UArrayCD *VectIn, struct UArrayCD *VectOut);
/*----------------------------------------------------------------------*/
void UACFfft(struct UArrayCF *Vect,long msign);
/*----------------------------------------------------------------------*/
void UADAdd(struct UArrayD *mat1, struct UArrayD *mat2, struct UArrayD *matOut);
void UADCopy(struct UArrayD *In, struct UArrayD *Out);
void UADfft(struct UArrayD *Vect,long msign);
#define UADFree(mat) FrVectDFree(mat);
double UADInv(struct UArrayD *in, struct UArrayD *out);
#define UADNew(nL,nC) FrVectDNew(nL,nC);
void UADPolProdV(struct UArrayD *Vect1, struct UArrayD *Vect2, 
                 struct UArrayD *VectOut);
long UADPolRootV(struct UArrayD *polyn, struct UArrayCD *root);
void UADProd(struct UArrayD *mat1, struct UArrayD *mat2, struct UArrayD *matOut);
void UADrk4(struct UArrayD *matA, struct UArrayD *matB,
            struct UArrayD *matC, struct UArrayD *matD, 
            struct UArrayD *matY, struct UArrayD *matU, 
            struct UArrayD *matX0, double  pas);
void UADScal(struct UArrayD *in,double  factor, struct UArrayD *out);
void UADSub(struct UArrayD *mat1, struct UArrayD *mat2, struct UArrayD *matOut);
void UADTran(struct UArrayD *in, struct UArrayD *out);
void UADValVec(struct UArrayD *matA, struct UArrayD *matZ, 
               struct UArrayCD *matW, long *low, long *igh, long *ierr);
void UADvvBalanc(struct UArrayD *matA, long *low, long *igh, double *scale);
void UADvvElmhes(struct UArrayD *matA, long *low, long *igh, long *inte);
void UADvvEltran(struct UArrayD *matA, struct UArrayD *matZ, 
                long *low, long *igh, long *inte);
void UADvvMulcpx2(double a,double b,double c,double d,double *x,double *y);
void UADvvBalbak(struct UArrayD *matZ,
                 long *low, long *igh, double *scale,  long m);
void UADvvHqr2(struct UArrayD *matA, struct UArrayCD *matW,
               struct UArrayD *matZ, long *low, long *igh, long *ierr);
void UADExpm(struct UArrayD *matIn,struct UArrayD *matOut);
void UADC2d(struct UArrayD *A, struct UArrayD*B, 
            struct UArrayD *Ad, struct UArrayD*Bd, double t);
/*----------------------------------------------------------------------*/
#define UAFNew(nL,nC) FrVectFNew(nL,nC);
/*----------------------------------------------------------------------*/
void UAfillDSim(struct UArrayFillD *,long);
void UAfillDRead(struct UJfile *iFile);
/*----------------------------------------------------------------------*/
void UAfillFSim(struct UArrayFillF *,long);
void UAfillFRead(struct UJfile *iFile);

#endif
