/* ***************************************************************
************* UMath.h *************************** UMath.h ********
************* UMath.h *************************** UMath.h ********
*************************************************************** */
/* From LAPP (Annecy) and Cavalier Fabien LAL (Orsay)*/
/* February 09, 1998  */

#if !defined(SUTIL_DEFINED)
#define SUTIL_DEFINED DONE

#if !defined(MYBOOL)
typedef long BOOL;
typedef double COMPLEX_D; 
typedef float  COMPLEX_F;
#define MYBOOL ...
#endif

#include "UArrayL.h"

#define YES 1
#define NO  0

#define SIESTA_MAX(A,B) ((A) > (B) ? (A) : (B))
#define SIESTA_MIN(A,B) ((A) < (B) ? (A) : (B))

#define HCINV     5.0341125E+24
#define PI        3.1415926535897932385
#define TWOPI     6.2831853071795864769
#define TWOOVERPI 6.3661977236758134308E-1
#define PI2       1.5707963267948966192
#define BOLTZMANN 1.380658E-23
#define VLIGHT    299792458.
#define SQRT2     1.4142135623730950488
#define INVSQRT2  7.0710678118654752440E-1

/* Definitions and Structures for Fitting Routines */
#define MAXTRY 10000

struct UMmesu {
  struct UArrayD *xmesured;
  struct UArrayD *ymesured;
  struct UArrayD *yerrors;
  double (*ypredicted)();
  void (*derivative)();
  struct UArrayD *areturned;
  struct UArrayD *aestimated;
  struct UArrayD *acovar;
               };

struct UMmini {
  double chi2;
  struct UArrayD *alpha;
  struct UArrayD *beta;
  struct UArrayD *atry;
            };

double UMpHermite(long n, double x);
float UMrandom(long i);
double UMrgausd(long i);
float UMrgausf(long i);
double UMminimize(struct UArrayD *xmesured, struct UArrayD *ymesured,
             struct UArrayD *yerrors, double (*fctfit)(), void (*derivative)(),
             struct UArrayD *param, struct UArrayD *active, struct UArrayD *errmatx);
void UMchi2(struct UMmesu *mesu, struct UMmini *mini);
void UMhessian(struct UMmesu *mesu, struct UMmini *mini);

#endif
