/* ******************************************************************
******** USignalL.c *************************** USignalL.c **********
******** USignalL.c *************************** USignalL.c **********
****************************************************************** */
/* by R. Flaminio and F. Marion LAPP (Annecy), A.Vicere' (Pisa) */
/* modified on 13/03/2000 by D. Verkindt (fix some memory leaks) */


char USversion[] = "March 13 2000";

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <glob.h>
#include <sys/stat.h>
#include <unistd.h>
#include "USignalL.h"
#include "URootAccess.h"
#ifdef MEMWATCH
#    include "memwatch.h"
#endif

struct UJstructH *USadcUJstructH;
struct UJstructH *USadderUJstructH;
struct UJstructH *USaverageUJstructH;
struct UJstructH *UScosUJstructH;
struct UJstructH *UScosineUJstructH;
struct UJstructH *USdelayUJstructH;
struct UJstructH *USdivideUJstructH;
struct UJstructH *USfilterUJstructH;
struct UJstructH *USfilter1UJstructH;
struct UJstructH *USfilter2UJstructH;
struct UJstructH *USfilter3UJstructH;
struct UJstructH *USfilter4UJstructH;
struct UJstructH *USfilter5UJstructH;
struct UJstructH *USfreqSelUJstructH;
struct UJstructH *USgeneratorUJstructH;
struct UJstructH *USifUJstructH;
struct UJstructH *USifMUJstructH;
struct UJstructH *USignalUJstructH;
struct UJstructH *USignal6UJstructH;
struct UJstructH *US6SetUJstructH;
struct UJstructH *US6SmearUJstructH;
struct UJstructH *USsweepUJstructH;
struct UJstructH *UStransFUJstructH;
struct UJstructH *USburgUJstructH;
struct UJstructH *USimpulseUJstructH;

struct USignal  *USfirstSignal  = NULL;
struct USignal6 *USfirstSignal6 = NULL;
struct USadder  *USfirstAdder   = NULL;


/*------------------------------------------------------ USLibIni -*/
void USLibIni()
/*-----------------------------------------------------------------*/
{
 static BOOL first=YES;

 if (first == NO)  return;
 first = NO; 
 
/***
 fprintf(UJobH.fOut,"   USignalL  Version:%s(%s%s %s)\n",USversion
         ,__DATE__,__TIME__,__FILE__);
***/

 USadcUJstructH       = UJDicAddS("USadc",USadcIni,USadcSim,USadcEnd,USadcRead,USadcFree);
 USadderUJstructH     = UJDicAddS("USadder",NULL,USadderSim,NULL,USadderRead,USadderFree);
 USadderUJstructH->objMsg = USadderMsg;
 USaverageUJstructH   = UJDicAddS("USaverage",USaverageIni,USaverageSim,NULL,USaverageRead,USaverageFree);
 UScosUJstructH       = UJDicAddS("UScos",NULL,UScosSim,NULL,UScosRead,UScosFree);
 UScosineUJstructH    = UJDicAddS("UScosine",UScosineIni,UScosineSim,NULL,UScosineRead,UScosineFree);
 USdelayUJstructH     = UJDicAddS("USdelay",USdelayIni,USdelaySim,NULL,USdelayRead,USdelayFree);
 USdivideUJstructH    = UJDicAddS("USdivide",NULL, USdivideSim,NULL,USdivideRead,USdivideFree);
 USfilterUJstructH    = UJDicAddS("USfilter",USfilterIni,USfilterSim,NULL,USfilterRead,USfilterFree);
 USfilter1UJstructH   = UJDicAddS("USfilter1",USfilter1Ini,USfilter1Sim,NULL,USfilter1Read,USfilter1Free);
 USfilter2UJstructH   = UJDicAddS("USfilter2",USfilter2Ini,USfilter2Sim,NULL,USfilter2Read,USfilter2Free);
 USfilter3UJstructH   = UJDicAddS("USfilter3",USfilter3Ini,USfilter3Sim,NULL,USfilter3Read,USfilter3Free);
 USfilter4UJstructH   = UJDicAddS("USfilter4",USfilter4Ini,USfilter4Sim,NULL,USfilter4Read,USfilter4Free);
 USfilter5UJstructH   = UJDicAddS("USfilter5",USfilter5Ini,USfilter5Sim,NULL,USfilter5Read,USfilter5Free);
 USfreqSelUJstructH   = UJDicAddS("USfreqSel",USfreqSelIni,USfreqSelSim,NULL,USfreqSelRead,NULL);
 USgeneratorUJstructH = UJDicAddS("USgenerator",USgeneIni,USgeneSim,NULL,USgeneRead,USgeneFree);
 USifUJstructH        = UJDicAddS("USif",USifIni,USifSim,NULL,USifRead,NULL);
 USifMUJstructH       = UJDicAddS("USifM",USifMIni,USifMSim, NULL,USifMRead,USifMFree);
 USignalUJstructH     = UJDicAddS("USignal", NULL, NULL, USignalEnd, USignalRead, NULL);
 USignal6UJstructH    = UJDicAddS("USignal6", NULL, NULL, NULL, NULL, NULL);
 US6SetUJstructH      = UJDicAddS("US6Set",NULL, US6SetSim, NULL, US6SetRead, US6SetFree);
 US6SmearUJstructH    = UJDicAddS("US6Smear", US6SmearIni, US6SmearSim, NULL, US6SmearRead, US6SmearFree);
 USsweepUJstructH     = UJDicAddS("USsweep", USsweepIni, USsweepSim, NULL, USsweepRead, USsweepFree);
 UStransFUJstructH    = UJDicAddS("UStransF", NULL, NULL, UStransFEnd, UStransFRead, NULL);
 USburgUJstructH      = UJDicAddS("USburg", USburgIni, USburgSim, USburgEnd, USburgRead, USburgFree);
 USimpulseUJstructH   = UJDicAddS("USimpulse",USimpulseIni,USimpulseSim,USimpulseEnd,USimpulseRead,USimpulseFree);

 return;
}


/*------------------------------------------------------ USadcEnd ----*/
void USadcEnd(adc)
struct USadc *adc;
/*--------------------------------------------------------------------*/
{
 if (UJobH.debugLvl < 1)  return;
 if (adc->autoSet == NO)  return;

 fprintf(UJobH.fOut," \n The input gain was %e for adc:%s\n",adc->iGain,adc->name);
 
 return;
}


/*------------------------------------------------------ USadcFree ---*/
void USadcFree(adc)
struct USadc *adc;
/*--------------------------------------------------------------------*/
{
 if (adc->name != NULL)  free(adc->name);
  
 USignalFree(adc->out); 
 free(adc);
 return;
}


/*------------------------------------------------------ USadcIni ----*/
void USadcIni(adc, dt)
struct USadc *adc;
double dt;
/*--------------------------------------------------------------------*/
{
 long i;

 adc->dynamic = 1;
 for (i=0; i<adc->nBits-1; i++)  adc->dynamic = adc->dynamic*2;

 adc->iGain = adc->inputGain * adc->dynamic / adc->range;

 if (adc->iGain != 0.)  adc->oGain = adc->overallGain / adc->iGain; 
 else                   adc->oGain = 0.; 

 if (adc->inputGain == 0.) 
    {adc->iGain   = 1.e+30;
     adc->autoSet = YES;
    }
 else
    {adc->autoSet = NO;}

 return;
}


/*------------------------------------------------------ USadcRead ---*/
void USadcRead(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
 struct USadc *adc;

 UJ_READ_HEADER_WITH_NAME(USadc, adc)
 
 UJ_READ_LONG(adc->iClock)
 UJ_READ_STRUCT(USignal, adc->input)
 UJ_READ_DOUBLE(adc->inputGain)
 UJ_READ_DOUBLE(adc->overallGain)
 UJ_READ_DOUBLE(adc->range)
 UJ_READ_DOUBLE(adc->noise)
 UJ_READ_LONG(adc->nBits)
  
 strcpy(bankName,adc->name);
 adc->out = USignalNew(strcat(bankName,".out"), iFile->ascii); 

 UJCObAdd(adc->iClock,adc,USadcUJstructH,adc->name);
  
 return;
}


/*------------------------------------------------------ USadcSim ----*/
void USadcSim(adc, time)  
struct USadc *adc;
long time;
/*--------------------------------------------------------------------*/
{
 long ivalue;
 double value;
	  
 value = adc->input->value * adc->iGain;

 if (adc->noise > 0.) value += adc->noise * UMrgausd(0);
  
 if (adc->autoSet == YES)
    {if (fabs(value) > 0.98*adc->dynamic)
        {adc->iGain  = 0.75 * adc->dynamic / fabs(adc->input->value);
         adc->oGain = adc->overallGain / adc->iGain;
         printf(" Time=%8ld Set input gain to %e for adc:%s\n",time,
                 adc->iGain*adc->range/adc->dynamic, adc->name);
         value = adc->input->value * adc->iGain;
         }
    }

 if (value > 0.)  ivalue = (long) ( 0.5 + value);
 else             ivalue = (long) (-0.5 + value);
  
 if (ivalue >  adc->dynamic)  ivalue =  adc->dynamic;
 if (ivalue < -adc->dynamic)  ivalue = -adc->dynamic;
 adc->out->value = adc->oGain * (double)ivalue;
    
 return;
}


/*-------------------------------------------------USadderFree------*/
void USadderFree(adder)
struct USadder *adder;
/*-----------------------------------------------------------------*/
{
 if (adder->name != NULL)  free(adder->name);

 USignalFree(adder->out);
 free(adder);
 return;
}


/*----------------------------------------------------- USadderMsg--*/
void USadderMsg(adder, msgType, param, reportL, report)
struct USadder *adder;
char *msgType, *param, *report;
long reportL;
/*-----------------------------------------------------------------*/
{
 long i;
 double gain;

 if (adder == NULL)
    {sprintf(report,"adder structure not found");}
 
 else if (strcmp(msgType, "dump") == 0)
    {
     sprintf(report,"%s %ld %ld", adder->name, adder->iClock, adder->nSignal); 
     for (i=0; i<adder->nSignal; i++)
          {sprintf(&report[strlen(report)]," %s", adder->input[i]->name);} 
     for (i=0; i<adder->nSignal; i++)
          {sprintf(&report[strlen(report)]," %e",adder->param[i]);}
    }

 else if(strcmp(msgType, "newGain") == 0)
    {
     sscanf(param,"%ld %lf", &i, &gain);
     if (i >= adder->nSignal  ||  i < 0)
        {sprintf(report,"bad signal number");}
     else
        {adder->param[i] = gain;
         sprintf(report,"parameter changed");
        }
    }

 else
    {sprintf(report,"unknown message\n");}

 return;
}


/*----------------------------------------------------- USadderRead--*/
void USadderRead(iFile)
struct UJfile *iFile;
/*-----------------------------------------------------------------*/
{
 struct USadder *adder, *last;
 long i; 

 UJ_READ_HEADER_WITH_NAME(USadder, adder)
 
 UJ_READ_LONG(adder->iClock);
 UJ_READ_LONG(adder->nSignal);
 if (adder->nSignal > USMAXINPUT)  UJError(3,"USadderRead","too many inputs");

 for (i=0; i<adder->nSignal; i++)
    {UJ_READ_STRUCT(USignal, adder->input[i]);} 

 for (i=0; i<adder->nSignal; i++)
    {UJ_READ_DOUBLE(adder->param[i]);}
       
 strcpy(bankName, adder->name);
 adder->out = USignalNew(strcat(bankName,".out"), iFile->ascii); 

 UJCObAdd(adder->iClock,adder,USadderUJstructH,adder->name);
 
 adder->next = NULL;
 if (USfirstAdder  == NULL)
    {USfirstAdder = adder;}
 else
    {last = USfirstAdder;
     while (last->next != NULL) last = last->next;
     last->next = adder;
    }
 
 return;
}


/*--------------------------------------------------- USadderSim ----*/
void USadderSim(adder, time)
struct USadder *adder;
long time;
/*-----------------------------------------------------------------*/
{
 long i;
   
 adder->out->value = 0.;
 for (i=0; i<adder->nSignal; i++)
    {adder->out->value += adder->param[i] * adder->input[i]->value;}
 
 return;
}


/*------------------------------------------------------ USaverageFree ---*/
void USaverageFree(average)
struct USaverage *average;
/*--------------------------------------------------------------------*/
{
 if (average->name != NULL)  free(average->name);
  
 USignalFree(average->out); 
 free(average);
 return;
}


/*-------------------------------------------------- USaverageIni ----*/
void USaverageIni(average, dt)
struct USaverage *average;
double dt;
/*--------------------------------------------------------------------*/
{
 average->index = 0;
 average->buf   = 0.;
 return;
}


/*-------------------------------------------------- USaverageRead ---*/
void USaverageRead(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
 struct USaverage *average;

 UJ_READ_HEADER_WITH_NAME(USaverage, average)
 
 UJ_READ_LONG(average->iClock)
 UJ_READ_STRUCT(USignal,average->input)
 UJ_READ_LONG(average->n)
  
 strcpy(bankName, average->name);
 average->out = USignalNew(strcat(bankName,".out"), iFile->ascii); 
 
 UJCObAdd(average->iClock, average, USaverageUJstructH, average->name);
  
 return;
}


/*-------------------------------------------------- USaverageSim ----*/
void USaverageSim(average, time)  
struct USaverage *average;
long time;
/*--------------------------------------------------------------------*/
{	  
 average->buf += average->input->value;
 average->index++;

 if (average->index == average->n)
    {average->out->value = average->buf / (double)average->n;
     average->index      = 0;
     average->buf        = 0.;
    }

 return;
}


/*--------------------------------------------------UScosFree------*/
void UScosFree(cosine)
struct UScos *cosine;
/*--------------------------------------------------------------------*/
{
 if (cosine->name != NULL)  free(cosine->name);

 USignalFree(cosine->cosine);
 USignalFree(cosine->sine);
 free(cosine);
 return;
}


/*-------------------------------------------------- UScosRead ----*/
void UScosRead(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
 struct UScos *cosine;

 UJ_READ_HEADER_WITH_NAME(UScos, cosine)
 
 UJ_READ_LONG(cosine->iClock);
 UJ_READ_STRUCT(USignal, cosine->input);

 strcpy(bankName,cosine->name);
 cosine->cosine = USignalNew(strcat(bankName,".cosine"), iFile->ascii);
 strcpy(bankName,cosine->name);
 cosine->sine   = USignalNew(strcat(bankName,".sine"), iFile->ascii);
 
 UJCObAdd(cosine->iClock,cosine,UScosUJstructH,cosine->name);
  
 return;
}

 
/*--------------------------------------------------- UScosSim ----*/
void UScosSim(cosine, time)
struct UScos *cosine;
long time;
/*--------------------------------------------------------------------*/
{ 
 cosine->cosine->value = cos(cosine->input->value);
 cosine->sine->value   = sin(cosine->input->value);
 return;
}


/*--------------------------------------------------UScosineFree------*/
void UScosineFree(cosine)
struct UScosine *cosine;
/*--------------------------------------------------------------------*/
{
 if (cosine->name != NULL)  free(cosine->name);

 USignalFree(cosine->out);
 free(cosine);
 return;
}


/*--------------------------------------------------- UScosineIni ----*/
void UScosineIni(cosine, dt)
struct UScosine *cosine;
double dt;
/*--------------------------------------------------------------------*/
{ 
 if (cosine == NULL)  UJError(3,"cosineIni","no cosine");
 
 cosine->phase      = cosine->phase0;
 cosine->dPhi       = dt * TWOPI * cosine->frequency;
 cosine->out->value = cosine->amplitude * cos(cosine->phase);
 return;
}


/*-------------------------------------------------- UScosineRead ----*/
void UScosineRead(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
 struct UScosine *cosine;

 UJ_READ_HEADER_WITH_NAME(UScosine, cosine)
 
 UJ_READ_LONG(cosine->iClock)
 UJ_READ_DOUBLE(cosine->amplitude)
 UJ_READ_DOUBLE(cosine->frequency)
 UJ_READ_DOUBLE(cosine->phase0)

 strcpy(bankName,cosine->name);
 cosine->out = USignalNew(strcat(bankName,".out"), iFile->ascii);
 
 UJCObAdd(cosine->iClock,cosine,UScosineUJstructH,cosine->name);
  
 return;
}

 
/*--------------------------------------------------- UScosineSim ----*/
void UScosineSim(cosine, time)
struct UScosine *cosine;
long time;
/*--------------------------------------------------------------------*/
{ 
 cosine->phase = cosine->phase + cosine->dPhi;
 while (cosine->phase > TWOPI) {cosine->phase = cosine->phase - TWOPI;}

 cosine->out->value = cosine->amplitude * cos(cosine->phase);
 return;
}


/*--------------------------------------------------USdelayFree------*/
void USdelayFree(delay)
struct USdelay *delay;
/*--------------------------------------------------------------------*/
{
 if (delay->name != NULL)  free(delay->name);

 USignalFree(delay->out);
 free(delay);
 return;
}


/*--------------------------------------------------- USdelayIni ----*/
void USdelayIni(delay, dt)
struct USdelay *delay;
double dt;
/*--------------------------------------------------------------------*/
{ 
 if (delay == NULL)  UJError(3,"delayIni","no delay");
 
 delay->deep = (int) ((0.5*dt+delay->time) / dt);

 if (UJobH.debugLvl > 1)
    {fprintf(UJobH.fOut, "   for USdelay =%s\n time=%e dt=%e deep=%ld\n",
                         delay->name, delay->time, dt, delay->deep);
    }

 delay->buffer = (double *) calloc(delay->deep, sizeof(double));
 if (delay->buffer == NULL)  UJError(3,"USdelayIni","malloc failed");

 delay->out->value = 0.;

 return;
}


/*-------------------------------------------------- USdelayRead ----*/
void USdelayRead(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
 struct USdelay *delay;

 UJ_READ_HEADER_WITH_NAME(USdelay, delay)
 
 UJ_READ_LONG(delay->iClock)
 UJ_READ_STRUCT(USignal, delay->input)
 UJ_READ_DOUBLE(delay->time)

 strcpy(bankName,delay->name);
 delay->out = USignalNew(strcat(bankName,".out"), iFile->ascii);
 
 UJCObAdd(delay->iClock,delay,USdelayUJstructH,delay->name);
  
 return;
}

 
/*--------------------------------------------------- USdelaySim ----*/
void USdelaySim(delay, time)
struct USdelay *delay;
long time;
/*--------------------------------------------------------------------*/
{
 int i;

 delay->out->value = delay->buffer[0];

 for (i=0; i<delay->deep-1; i++)
    {delay->buffer[i] = delay->buffer[i+1];}

 delay->buffer[delay->deep-1] = delay->input->value;

 return;
}


/*-------------------------------------------------USdivideFree------*/
void USdivideFree(divide)
struct USdivide *divide;
/*--------------------------------------------------------------------*/
{
 if (divide->name != NULL)  free(divide->name);

 USignalFree(divide->out);
 free(divide);
 return;
}


/*---------------------------------------------------- USdivideRead ----*/
void USdivideRead(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
 struct USdivide *divide;

 UJ_READ_HEADER_WITH_NAME(USdivide, divide)
 
 UJ_READ_LONG(divide->iClock)
 UJ_READ_STRUCT(USignal, divide->input1)
 UJ_READ_STRUCT(USignal, divide->input2)

 strcpy(bankName,divide->name);
 divide->out = USignalNew(strcat(bankName,".out"), iFile->ascii);
 
 if (UJobH.debugLvl > 1)
    {fprintf(UJobH.fOut,"   input1 USignal =%s\n  input2 USignal =%s\n  output USignal =%s\n",
             divide->input1->name, divide->input2->name, divide->out->name);
    }
    
 UJCObAdd(divide->iClock,divide,USdivideUJstructH,divide->name);
  
 return;
}


/*--------------------------------------------------- USdivideSim ----*/
void USdivideSim(divide, time)
struct USdivide *divide;
long time;
/*--------------------------------------------------------------------*/
{  
 if (divide == NULL)  UJError(3,"USdivideSim","no divide"); 
 if (divide->input2->value == 0.) return;

 divide->out->value = divide->input1->value / divide->input2->value; 

 return;
}

 
/*-------------------------------------------------USfilterFree------*/
void USfilterFree(filter)
struct USfilter *filter;
/*-----------------------------------------------------------------*/
{
 if (filter->name != NULL)  free(filter->name);

 USignalFree(filter->out);
 UADFree (filter->ad);
 UADFree (filter->bd);
 UADFree (filter->c);
 UADFree (filter->x);
 UADFree (filter->xtemp);
 UADFree (filter->d);
 UADFree (filter->u);
 UADFree (filter->y);
 UADFree (filter->ytemp);

 free(filter);
 return;
}


/*--------------------------------------------------- USfilterIni ----*/
void USfilterIni(filter, dt)
struct USfilter *filter;
double dt;
/*----------------------------------------------------------------*/
{
 long i, j, m, n;
 struct UArrayD *ac, *bc;

 if (filter == NULL)  UJError(3,"USfilterIni","no filter");

 m  = filter->degnum;
 n  = filter->degden;

 ac = (struct UArrayD*) UADNew(n, n);
 if (ac == NULL)  UJError(3,"filterIni","malloc failed");
 bc = (struct UArrayD*) UADNew(n, 1);
 if (bc == NULL)  UJError(3,"filterIni","malloc failed");

 filter->ad    = (struct UArrayD*) UADNew(n, n);
 if (filter->ad == NULL)     UJError(3,"filterIni","malloc failed");
 filter->bd    = (struct UArrayD*) UADNew(n, 1);
 if (filter->bd == NULL)     UJError(3,"filterIni","malloc failed");
 filter->c     = (struct UArrayD*) UADNew(1, n);
 if (filter->c == NULL)      UJError(3,"filterIni","malloc failed");
 filter->x     = (struct UArrayD*) UADNew(n, 1);
 if (filter->x == NULL)      UJError(3,"filterIni","malloc failed");
 filter->xtemp = (struct UArrayD*) UADNew(n, 1);
 if (filter->xtemp == NULL)  UJError(3,"filterIni","malloc failed");
 filter->d     = (struct UArrayD*) UADNew(1, 1);
 if (filter->d == NULL)      UJError(3,"filterIni","malloc failed");
 filter->u     = (struct UArrayD*) UADNew(1, 1);
 if (filter->u == NULL)      UJError(3,"filterIni","malloc failed");
 filter->y     = (struct UArrayD*) UADNew(1, 1);
 if (filter->y == NULL)      UJError(3,"filterIni","malloc failed");
 filter->ytemp = (struct UArrayD*) UADNew(1, 1);
 if (filter->ytemp == NULL)  UJError(3,"filterIni","malloc failed");

 for (i=0; i<n-1; i++)
    {j = i + 1;
     ac->dataD[i*n+j] = 1.;
    }
 i = n - 1;

 for (j=0; j<n; j++)
    {ac->dataD[i*n+j] = - filter->b[j] / filter->b[n];}

 bc->dataD[n-1] = 1. / filter->b[n];

 if (m < n)
    {for (j=0; j<=m; j++)
        {filter->c->dataD[j] = filter->a[j];}
     filter->d->dataD[0] = 0.;
    }

 if (m == n)
    {for (j=0; j<n; j++)
        {filter->c->dataD[j] = filter->a[j] - filter->b[j] * filter->a[n]/filter->b[n];}
     filter->d->dataD[0] = filter->a[n] / filter->b[n];
    }

 UADC2d(ac, bc, filter->ad, filter->bd, dt);

 for (i=0; i<n; i++)  filter->x->dataD[i] = 0.;
      
 return;
}


/*----------------------------------------------- USfilterRead ----*/
void USfilterRead(iFile)
struct UJfile *iFile;
/*-----------------------------------------------------------------*/
{
 long i;
 struct USfilter *filter;

 UJ_READ_HEADER_WITH_NAME(USfilter, filter)
 UJ_READ_STRUCT(USignal, filter->input)
 UJ_READ_LONG(filter->iClock);

 UJ_READ_LONG(filter->nNum);
 filter->degnum   = filter->nNum - 1;
 filter->aReverse = (double*)malloc(sizeof(double)*(filter->nNum));
 filter->a        = (double*)malloc(sizeof(double)*(filter->nNum));
 if (filter->aReverse == NULL  ||  filter->a == NULL)  UJError(3,"filterRead","malloc failed");
 for (i=0; i<filter->nNum; i++)
    {UJ_READ_DOUBLE(filter->aReverse[i]);
     filter->a[filter->degnum-i] = filter->aReverse[i];
    }

 UJ_READ_LONG(filter->nDen);
 filter->degden   = filter->nDen-1;
 filter->bReverse = (double*)malloc(sizeof(double)*(filter->nDen));
 filter->b        = (double*)malloc(sizeof(double)*(filter->nDen));
 if (filter->bReverse == NULL  ||  filter->b == NULL)  UJError(3,"filterRead","malloc failed");
 for (i=0; i<filter->nDen; i++)
    {UJ_READ_DOUBLE(filter->bReverse[i]);
     filter->b[filter->degden-i] = filter->bReverse[i];
    }

 if (filter->degnum > filter->degden)
    {UJError(3,"filterRead","degree of numerator larger than degree of denominator");}

 strcpy(bankName,filter->name);
 filter->out = USignalNew(strcat(bankName,".out"), iFile->ascii);

 UJCObAdd(filter->iClock,filter,USfilterUJstructH,filter->name);

 return;
}


/*--------------------------------------------------- USfilterSim ----*/
void USfilterSim(filter, time)
struct USfilter *filter;
long time;
/*-----------------------------------------------------------------*/
{
 if (filter == NULL)  UJError(3,"USfilterSim","no filter");
 
 filter->u->dataD[0] = filter->input->value;

 UADProd (filter->c, filter->x, filter->y);
 UADProd (filter->d, filter->u, filter->ytemp);
 UADAdd  (filter->y, filter->ytemp, filter->y);

 UADProd (filter->ad, filter->x, filter->xtemp);
 UADProd (filter->bd, filter->u, filter->x);
 UADAdd  (filter->x,  filter->xtemp, filter->x);

 filter->out->value = filter->y->dataD[0];

 return;
}
 

/*-------------------------------------------------USfilter1Free------*/
void USfilter1Free(filter)
struct USfilter1 *filter;
/*-----------------------------------------------------------------*/
{
 if (filter->name != NULL)  free(filter->name);

 USignalFree(filter->out);
 free(filter);
 return;
}


/*--------------------------------------------------- USfilter1Ini ----*/
void USfilter1Ini(filter, dt)
struct USfilter1 *filter;
double dt;
/*----------------------------------------------------------------*/
{
 double fs; 

 if (filter == NULL)  UJError(3,"USfilter1Ini","no filter");
 
 fs = 1. / dt;

 filter->alfa1 = -2. * filter->a1 * fs  + filter->a0;  
 filter->alfa0 =  2. * filter->a1 * fs  + filter->a0;  
 filter->beta1 = -2. * filter->b1 * fs  + filter->b0;  
 filter->beta0 =  2. * filter->b1 * fs  + filter->b0;

 filter->alfa1 =   filter->alfa1 / filter->beta0;
 filter->alfa0 =   filter->alfa0 / filter->beta0;
 filter->beta1 = - filter->beta1 / filter->beta0;

 filter->reg1  = 0.;
 filter->reg0  = 0.;

 return;
}


/*-------------------------------------------------- USfilter1Read ----*/
void USfilter1Read(iFile)
struct UJfile *iFile;
/*-----------------------------------------------------------------*/
{
 struct USfilter1 *filter;

 UJ_READ_HEADER_WITH_NAME(USfilter1, filter)
 
 UJ_READ_STRUCT(USignal, filter->input)
 UJ_READ_LONG(filter->iClock)
 UJ_READ_DOUBLE(filter->a1)
 UJ_READ_DOUBLE(filter->a0)
 UJ_READ_DOUBLE(filter->b1)
 UJ_READ_DOUBLE(filter->b0)

 strcpy(bankName,filter->name);
 filter->out = USignalNew(strcat(bankName,".out"), iFile->ascii);
 
 if (UJobH.debugLvl > 1)
    {fprintf(UJobH.fOut,"   input USignal =%s\n   a= %e %e\n   b= %e %e\n",
                        filter->name,filter->a1,filter->a0, filter->b1,filter->b0);
    }
    
 UJCObAdd(filter->iClock,filter,USfilter1UJstructH,filter->name);
  
 return;
}


/*--------------------------------------------------- USfilter1Sim ----*/
void USfilter1Sim(filter, time)
struct USfilter1 *filter;
long time;
/*-----------------------------------------------------------------*/
{  
 if (filter == NULL)  UJError(3,"USfilter1Sim","no filter");

 filter->reg1       = filter->reg0;
 filter->reg0       = filter->input->value         + filter->beta1 * filter->reg1;
 filter->out->value = filter->alfa0 * filter->reg0 + filter->alfa1 * filter->reg1;

 return;
}

 
/*-------------------------------------------------USfilter2Free------*/
void USfilter2Free(filter)
struct USfilter2 *filter;
/*--------------------------------------------------------------------*/
{
 if (filter->name != NULL)  free(filter->name);

 USignalFree(filter->out);
 free(filter);
 return;
}


/*--------------------------------------------------- USfilter2Ini ----*/
void USfilter2Ini(filter, dt)
struct USfilter2 *filter;
double dt;
/*--------------------------------------------------------------------*/
{
 double fs; 

 if (filter == NULL)  UJError(3,"USfilter2Ini","no filter");
 
 fs = 1. / dt;

 filter->alfa2 =   4. * filter->a2 * fs * fs  -  2. * filter->a1 * fs  +  filter->a0;  
 filter->alfa1 = - 8. * filter->a2 * fs * fs  +  2. * filter->a0;  
 filter->alfa0 =   4. * filter->a2 * fs * fs  +  2. * filter->a1 * fs  +  filter->a0;  
 filter->beta2 =   4. * filter->b2 * fs * fs  -  2. * filter->b1 * fs  +  filter->b0;  
 filter->beta1 = - 8. * filter->b2 * fs * fs  +  2. * filter->b0;  
 filter->beta0 =   4. * filter->b2 * fs * fs  +  2. * filter->b1 * fs  +  filter->b0;  

 filter->alfa2 =   filter->alfa2 / filter->beta0;
 filter->alfa1 =   filter->alfa1 / filter->beta0;
 filter->alfa0 =   filter->alfa0 / filter->beta0;
 filter->beta2 = - filter->beta2 / filter->beta0;
 filter->beta1 = - filter->beta1 / filter->beta0;

 filter->reg2  = 0.;
 filter->reg1  = 0.;
 filter->reg0  = 0.;

 return;
}


/*---------------------------------------------------- USfilter2Read ----*/
void USfilter2Read(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
 struct USfilter2 *filter;

 UJ_READ_HEADER_WITH_NAME(USfilter2, filter)
 
 UJ_READ_STRUCT(USignal, filter->input)
 UJ_READ_LONG(filter->iClock)
 UJ_READ_DOUBLE(filter->a2) 
 UJ_READ_DOUBLE(filter->a1)
 UJ_READ_DOUBLE(filter->a0)
 UJ_READ_DOUBLE(filter->b2)
 UJ_READ_DOUBLE(filter->b1)
 UJ_READ_DOUBLE(filter->b0)

 strcpy(bankName,filter->name);
 filter->out = USignalNew (strcat(bankName,".out"),iFile->ascii);
 
 if (UJobH.debugLvl > 1)
    {fprintf(UJobH.fOut,"   input USignal =%s\n   a=%e %e %e\n   b= %e %e %e\n",
                        filter->name,filter->a2,filter->a1,filter->a0,
                                     filter->b2,filter->b1,filter->b0);
    }
    
 UJCObAdd(filter->iClock,filter,USfilter2UJstructH,filter->name);
  
 return;
}


/*--------------------------------------------------- USfilter2Sim ----*/
void USfilter2Sim(filter, time)
struct USfilter2 *filter;
long time;
/*--------------------------------------------------------------------*/
{  
 if (filter == NULL)  UJError(3,"USfilter2Sim","no filter");
 
 filter->reg2       = filter->reg1;
 filter->reg1       = filter->reg0;
 filter->reg0       = filter->input->value 
                    + filter->beta1 * filter->reg1
                    + filter->beta2 * filter->reg2; 

 filter->out->value = filter->alfa0 * filter->reg0
                    + filter->alfa1 * filter->reg1
                    + filter->alfa2 * filter->reg2;

 return;
}

 
/*-------------------------------------------------USfilter3Free------*/
void USfilter3Free(filter)
struct USfilter3 *filter;
/*--------------------------------------------------------------------*/
{
 if (filter->name != NULL)  free(filter->name);

 USignalFree(filter->out);
 free(filter);
 return;
}


/*--------------------------------------------------- USfilter3Ini ----*/
void USfilter3Ini(filter, dt)
struct USfilter3 *filter;
double dt;
/*--------------------------------------------------------------------*/
{
 double fs; 

 if (filter == NULL)  UJError(3,"USfilter3Ini","no filter");
 
 fs = 1. / dt;

 filter->alfa3 = - 8. * filter->a3 * fs * fs * fs
                 + 4. * filter->a2 * fs * fs
                 - 2. * filter->a1 * fs
                 +      filter->a0;
 filter->alfa2 =  24. * filter->a3 * fs * fs * fs
                 - 4. * filter->a2 * fs * fs
                 - 2. * filter->a1 * fs
                 + 3. * filter->a0;
 filter->alfa1 = -24. * filter->a3 * fs * fs * fs
                 - 4. * filter->a2 * fs * fs
                 + 2. * filter->a1 * fs
                 + 3. * filter->a0;
 filter->alfa0 =   8. * filter->a3 * fs * fs * fs
                 + 4. * filter->a2 * fs * fs
                 + 2. * filter->a1 * fs
                 +      filter->a0;

 filter->beta3 = - 8. * filter->b3 * fs * fs * fs
                 + 4. * filter->b2 * fs * fs
                 - 2. * filter->b1 * fs
                 +      filter->b0;
 filter->beta2 =  24. * filter->b3 * fs * fs * fs
                 - 4. * filter->b2 * fs * fs
                 - 2. * filter->b1 * fs
                 + 3. * filter->b0;
 filter->beta1 = -24. * filter->b3 * fs * fs * fs
                 - 4. * filter->b2 * fs * fs
                 + 2. * filter->b1 * fs
                 + 3. * filter->b0;
 filter->beta0 =   8. * filter->b3 * fs * fs * fs
                 + 4. * filter->b2 * fs * fs
                 + 2. * filter->b1 * fs
                 +      filter->b0;

 filter->alfa3 =   filter->alfa3 / filter->beta0;
 filter->alfa2 =   filter->alfa2 / filter->beta0;
 filter->alfa1 =   filter->alfa1 / filter->beta0;
 filter->alfa0 =   filter->alfa0 / filter->beta0;
 filter->beta3 = - filter->beta3 / filter->beta0;
 filter->beta2 = - filter->beta2 / filter->beta0;
 filter->beta1 = - filter->beta1 / filter->beta0;

 filter->reg3  = 0.;
 filter->reg2  = 0.;
 filter->reg1  = 0.;
 filter->reg0  = 0.;

 return;
}


/*---------------------------------------------------- USfilter3Read ----*/
void USfilter3Read(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
 struct USfilter3 *filter;

 UJ_READ_HEADER_WITH_NAME(USfilter3, filter)
 
 UJ_READ_STRUCT(USignal, filter->input)
 UJ_READ_LONG(filter->iClock)
 UJ_READ_DOUBLE(filter->a3) 
 UJ_READ_DOUBLE(filter->a2) 
 UJ_READ_DOUBLE(filter->a1)
 UJ_READ_DOUBLE(filter->a0)
 UJ_READ_DOUBLE(filter->b3)
 UJ_READ_DOUBLE(filter->b2)
 UJ_READ_DOUBLE(filter->b1)
 UJ_READ_DOUBLE(filter->b0)

 strcpy(bankName,filter->name);
 filter->out = USignalNew(strcat(bankName,".out"), iFile->ascii);
 
 if (UJobH.debugLvl > 1)
    {fprintf(UJobH.fOut,"   input USignal =%s\n   a= %e %e %e %e\n   b= %e %e %e %e\n",
                        filter->name,filter->a3,filter->a2,filter->a1,filter->a0,
                                     filter->b3,filter->b2,filter->b1,filter->b0);
    }
    
 UJCObAdd(filter->iClock,filter,USfilter3UJstructH,filter->name);

 return;
}


/*--------------------------------------------------- USfilter3Sim ----*/
void USfilter3Sim(filter, time)
struct USfilter3 *filter;
long time;
/*--------------------------------------------------------------------*/
{
 if (filter == NULL)  UJError(3,"USfilter3Sim","no filter");
 
 filter->reg3       = filter->reg2;
 filter->reg2       = filter->reg1;
 filter->reg1       = filter->reg0;
 filter->reg0       = filter->input->value 
                    + filter->beta1 * filter->reg1
                    + filter->beta2 * filter->reg2
                    + filter->beta3 * filter->reg3;

 filter->out->value = filter->alfa0 * filter->reg0
                    + filter->alfa1 * filter->reg1
                    + filter->alfa2 * filter->reg2
                    + filter->alfa3 * filter->reg3;

 return;
}


/*-------------------------------------------------USfilter4Free------*/
void USfilter4Free(filter)
struct USfilter4 *filter;
/*--------------------------------------------------------------------*/
{
 if (filter->name != NULL)  free(filter->name);

 USignalFree(filter->out);
 free(filter);
 return;
}


/*--------------------------------------------------- USfilter4Ini ----*/
void USfilter4Ini(filter, dt)
struct USfilter4 *filter;
double dt;
/*--------------------------------------------------------------------*/
{
 double fs; 

 if (filter == NULL)  UJError(3,"USfilter4Ini","no filter");
 
 fs = 1./dt;

 filter->alfa4 =   16. * filter->a4 * fs * fs * fs * fs
                 -  8. * filter->a3 * fs * fs * fs
                 +  4. * filter->a2 * fs * fs 
                 -  2. * filter->a1 * fs
                 +       filter->a0;
 filter->alfa3 = - 64. * filter->a4 * fs * fs * fs * fs
                 + 16. * filter->a3 * fs * fs * fs
                 -  4. * filter->a1 * fs
                 +  4. * filter->a0;
 filter->alfa2 =   96. * filter->a4 * fs * fs * fs * fs
                 -  8. * filter->a2 * fs * fs
                 +  6. * filter->a0;
 filter->alfa1 = - 64. * filter->a4 * fs * fs * fs * fs
                 - 16. * filter->a3 * fs * fs * fs
                 +  4. * filter->a1 * fs
                 +  4. * filter->a0;
 filter->alfa0 =   16. * filter->a4 * fs * fs * fs * fs
                 +  8. * filter->a3 * fs * fs * fs
                 +  4. * filter->a2 * fs * fs 
                 +  2. * filter->a1 * fs
                 +       filter->a0;
 filter->beta4 =   16. * filter->b4 * fs * fs * fs * fs
                 -  8. * filter->b3 * fs * fs * fs
                 +  4. * filter->b2 * fs * fs 
                 -  2. * filter->b1 * fs
                 +       filter->b0;
 filter->beta3 = - 64. * filter->b4 * fs * fs * fs * fs
                 + 16. * filter->b3 * fs * fs * fs
                 -  4. * filter->b1 * fs
                 +  4. * filter->b0;
 filter->beta2 =   96. * filter->b4 * fs * fs * fs * fs
                 -  8. * filter->b2 * fs * fs
                 +  6. * filter->b0;
 filter->beta1 = - 64. * filter->b4 * fs * fs * fs * fs
                 - 16. * filter->b3 * fs * fs * fs
                 +  4. * filter->b1 * fs
                 +  4. * filter->b0;
 filter->beta0 =   16. * filter->b4 * fs * fs * fs * fs
                 +  8. * filter->b3 * fs * fs * fs
                 +  4. * filter->b2 * fs * fs 
                 +  2. * filter->b1 * fs
                 +       filter->b0;
 
 filter->alfa4 =   filter->alfa4 / filter->beta0;
 filter->alfa3 =   filter->alfa3 / filter->beta0;
 filter->alfa2 =   filter->alfa2 / filter->beta0;
 filter->alfa1 =   filter->alfa1 / filter->beta0;
 filter->alfa0 =   filter->alfa0 / filter->beta0;
 filter->beta4 = - filter->beta4 / filter->beta0;
 filter->beta3 = - filter->beta3 / filter->beta0;
 filter->beta2 = - filter->beta2 / filter->beta0;
 filter->beta1 = - filter->beta1 / filter->beta0;

 filter->reg4  = 0.;
 filter->reg3  = 0.;
 filter->reg2  = 0.;
 filter->reg1  = 0.;
 filter->reg0  = 0.;

 return;
}


/*---------------------------------------------------- USfilter4Read--*/
void USfilter4Read(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
 struct USfilter4 *filter;

 UJ_READ_HEADER_WITH_NAME(USfilter4, filter)
 
 UJ_READ_STRUCT(USignal, filter->input)
 UJ_READ_LONG(filter->iClock)
 UJ_READ_DOUBLE(filter->a4) 
 UJ_READ_DOUBLE(filter->a3) 
 UJ_READ_DOUBLE(filter->a2) 
 UJ_READ_DOUBLE(filter->a1)
 UJ_READ_DOUBLE(filter->a0)
 UJ_READ_DOUBLE(filter->b4)
 UJ_READ_DOUBLE(filter->b3)
 UJ_READ_DOUBLE(filter->b2)
 UJ_READ_DOUBLE(filter->b1)
 UJ_READ_DOUBLE(filter->b0)

 strcpy(bankName,filter->name);
 filter->out = USignalNew(strcat(bankName,".out"), iFile->ascii);
 
 if (UJobH.debugLvl > 1)
    {fprintf(UJobH.fOut,"   input USignal =%s\n   a= %e %e %e %e %e\n   b= %e %e %e %e %e\n",
                        filter->name,filter->a4,filter->a3,filter->a2,filter->a1,filter->a0,
                                     filter->b4,filter->b3,filter->b2,filter->b1,filter->b0);
    }
    
 UJCObAdd(filter->iClock,filter,USfilter4UJstructH,filter->name);
  
 return;
}


/*--------------------------------------------------- USfilter4Sim ----*/
void USfilter4Sim(filter, time)
struct USfilter4 *filter;
long time;
/*--------------------------------------------------------------------*/
{  
 if (filter == NULL)  UJError(3,"USfilter4Sim","no filter");
 
 filter->reg4       = filter->reg3;
 filter->reg3       = filter->reg2;
 filter->reg2       = filter->reg1;
 filter->reg1       = filter->reg0;
 filter->reg0       = filter->input->value 
                    + filter->beta1 * filter->reg1
                    + filter->beta2 * filter->reg2
                    + filter->beta3 * filter->reg3
                    + filter->beta4 * filter->reg4;

 filter->out->value = filter->alfa0 * filter->reg0
                    + filter->alfa1 * filter->reg1
                    + filter->alfa2 * filter->reg2
                    + filter->alfa3 * filter->reg3
                    + filter->alfa4 * filter->reg4;
 return;
}


/*-------------------------------------------------USfilter5Free------*/
void USfilter5Free(filter)
struct USfilter5 *filter;
/*--------------------------------------------------------------------*/
{
 if (filter->name != NULL)  free(filter->name);

 USignalFree(filter->out);
 free(filter);
 return;
}


/*--------------------------------------------------- USfilter5Ini ----*/
void USfilter5Ini(filter, dt)
struct USfilter5 *filter;
double dt;
/*--------------------------------------------------------------------*/
{
 double fs; 

 if (filter == NULL)  UJError(3,"USfilter5Ini","no filter");
 
 fs = 1. / dt;

 filter->alfa5 = -  32. * filter->a5 * fs * fs * fs * fs * fs
                 +  16. * filter->a4 * fs * fs * fs * fs
                 -   8. * filter->a3 * fs * fs * fs
                 +   4. * filter->a2 * fs * fs 
                 -   2. * filter->a1 * fs
                 +        filter->a0;
 filter->alfa4 =   160. * filter->a5 * fs * fs * fs * fs * fs
                 -  48. * filter->a4 * fs * fs * fs * fs
                 +   8. * filter->a3 * fs * fs * fs
                 +   4. * filter->a2 * fs * fs 
                 -   6. * filter->a1 * fs
                 +   5. * filter->a0;
 filter->alfa3 = - 320. * filter->a5 * fs * fs * fs * fs *fs
                 +  32. * filter->a4 * fs * fs * fs * fs
                 +  16. * filter->a3 * fs * fs * fs
                 -   8. * filter->a2 * fs * fs 
                 -   4. * filter->a1 * fs
                 +  10. * filter->a0;
 filter->alfa2 =   320. * filter->a5 * fs * fs * fs * fs * fs
                 +  32. * filter->a4 * fs * fs * fs * fs
                 -  16. * filter->a3 * fs * fs * fs
                 -   8. * filter->a2 * fs * fs
                 +   4. * filter->a1 * fs
                 +  10. * filter->a0;
 filter->alfa1 = - 160. * filter->a5 * fs * fs * fs * fs *fs
                 -  48. * filter->a4 * fs * fs * fs * fs
                 -   8. * filter->a3 * fs * fs * fs
                 +   4. * filter->a2 * fs * fs
                 +   6. * filter->a1 * fs
                 +   5. * filter->a0;  
 filter->alfa0 =    32. * filter->a5 * fs * fs * fs * fs *fs
                 +  16. * filter->a4 * fs * fs * fs * fs
                 +   8. * filter->a3 * fs * fs * fs
                 +   4. * filter->a2 * fs * fs 
                 +   2. * filter->a1 * fs
                 +        filter->a0;

 filter->beta5 = -  32. * filter->b5 * fs * fs * fs * fs * fs
                 +  16. * filter->b4 * fs * fs * fs * fs
                 -   8. * filter->b3 * fs * fs * fs
                 +   4. * filter->b2 * fs * fs 
                 -   2. * filter->b1 * fs
                 +        filter->b0;
 filter->beta4 =   160. * filter->b5 * fs * fs * fs * fs * fs
                 -  48. * filter->b4 * fs * fs * fs * fs
                 +   8. * filter->b3 * fs * fs * fs
                 +   4. * filter->b2 * fs * fs 
                 -   6. * filter->b1 * fs
                 +   5. * filter->b0;
 filter->beta3 = - 320. * filter->b5 * fs * fs * fs * fs *fs
                 +  32. * filter->b4 * fs * fs * fs * fs
                 +  16. * filter->b3 * fs * fs * fs
                 -   8. * filter->b2 * fs * fs 
                 -   4. * filter->b1 * fs
                 +  10. * filter->b0;
 filter->beta2 =   320. * filter->b5 * fs * fs * fs * fs * fs
                 +  32. * filter->b4 * fs * fs * fs * fs
                 -  16. * filter->b3 * fs * fs * fs
                 -   8. * filter->b2 * fs * fs
                 +   4. * filter->b1 * fs
                 +  10. * filter->b0;
 filter->beta1 = - 160. * filter->b5 * fs * fs * fs * fs *fs
                 -  48. * filter->b4 * fs * fs * fs * fs
                 -   8. * filter->b3 * fs * fs * fs
                 +   4. * filter->b2 * fs * fs
                 +   6. * filter->b1 * fs
                 +   5. * filter->b0;  
 filter->beta0 =    32. * filter->b5 * fs * fs * fs * fs *fs
                 +  16. * filter->b4 * fs * fs * fs * fs
                 +   8. * filter->b3 * fs * fs * fs
                 +   4. * filter->b2 * fs * fs 
                 +   2. * filter->b1 * fs
                 +        filter->b0;

 filter->alfa5 =   filter->alfa5 / filter->beta0;
 filter->alfa4 =   filter->alfa4 / filter->beta0;
 filter->alfa3 =   filter->alfa3 / filter->beta0;
 filter->alfa2 =   filter->alfa2 / filter->beta0;
 filter->alfa1 =   filter->alfa1 / filter->beta0;
 filter->alfa0 =   filter->alfa0 / filter->beta0;
 filter->beta5 = - filter->beta5 / filter->beta0;
 filter->beta4 = - filter->beta4 / filter->beta0;
 filter->beta3 = - filter->beta3 / filter->beta0;
 filter->beta2 = - filter->beta2 / filter->beta0;
 filter->beta1 = - filter->beta1 / filter->beta0;

 filter->reg5  = 0.;
 filter->reg4  = 0.;
 filter->reg3  = 0.;
 filter->reg2  = 0.;
 filter->reg1  = 0.;
 filter->reg0  = 0.;

 return;
}


/*---------------------------------------------------- USfilter5Read--*/
void USfilter5Read(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
 struct USfilter5 *filter;

 UJ_READ_HEADER_WITH_NAME(USfilter5, filter)
 
 UJ_READ_STRUCT(USignal, filter->input)
 UJ_READ_LONG(filter->iClock)
 UJ_READ_DOUBLE(filter->a5) 
 UJ_READ_DOUBLE(filter->a4) 
 UJ_READ_DOUBLE(filter->a3) 
 UJ_READ_DOUBLE(filter->a2) 
 UJ_READ_DOUBLE(filter->a1)
 UJ_READ_DOUBLE(filter->a0)
 UJ_READ_DOUBLE(filter->b5)
 UJ_READ_DOUBLE(filter->b4)
 UJ_READ_DOUBLE(filter->b3)
 UJ_READ_DOUBLE(filter->b2)
 UJ_READ_DOUBLE(filter->b1)
 UJ_READ_DOUBLE(filter->b0)

 strcpy(bankName,filter->name);
 filter->out = USignalNew(strcat(bankName,".out"), iFile->ascii);
 
 if (UJobH.debugLvl > 1)
    {fprintf(UJobH.fOut,
             "   input USignal =%s\n   a= %e %e %e %e %e %e\n   b= %e %e %e %e %e %e\n",
             filter->name,filter->a5,filter->a4,filter->a3,filter->a2,filter->a1,filter->a0,
                          filter->b5,filter->b4,filter->b3,filter->b2,filter->b1,filter->b0);
    }
    
 UJCObAdd(filter->iClock,filter,USfilter5UJstructH,filter->name);
  
 return;
}


/*--------------------------------------------------- USfilter5Sim ----*/
void USfilter5Sim(filter, time)
struct USfilter5 *filter;
long time;
/*--------------------------------------------------------------------*/
{  
 if (filter == NULL)   UJError(3,"USfilter5Sim","no filter");
 
 filter->reg5       = filter->reg4;
 filter->reg4       = filter->reg3;
 filter->reg3       = filter->reg2;
 filter->reg2       = filter->reg1;
 filter->reg1       = filter->reg0;
 filter->reg0       = filter->input->value 
                    + filter->beta1 * filter->reg1
                    + filter->beta2 * filter->reg2
                    + filter->beta3 * filter->reg3
                    + filter->beta4 * filter->reg4
                    + filter->beta5 * filter->reg5;

 filter->out->value = filter->alfa0 * filter->reg0
                    + filter->alfa1 * filter->reg1
                    + filter->alfa2 * filter->reg2
                    + filter->alfa3 * filter->reg3
                    + filter->alfa4 * filter->reg4
                    + filter->alfa5 * filter->reg5;
 return;
}


/*------------------------------------------------- USfreqSelIni -----*/
void USfreqSelIni(freqSel,dt)
struct USfreqSel *freqSel;
double dt;
/*--------------------------------------------------------------------*/
{
 long i;
 double win, winNorm;
 
 freqSel->nBin = 1;
 for (i=0; i<freqSel->nBinP2; i++)  freqSel->nBin = freqSel->nBin * 2;
 
 freqSel->dt     = dt;
 freqSel->dnu    = 1. / (freqSel->nBin*dt);
 freqSel->i      = 0;

 freqSel->vect   = UADNew(1,freqSel->nBin);
 freqSel->window = UADNew(1,freqSel->nBin);

 winNorm = 0.;
 for (i=0; i<freqSel->nBin; i++)
    {win = 0.5 * (1.+cos(TWOPI * (i - (freqSel->nBin-1)/2)/(freqSel->nBin-1)));
     freqSel->window->dataD[i] = win;
     winNorm += win*win;
    }

 freqSel->imin = (long)((freqSel->freq-freqSel->band/2)/ freqSel->dnu);
 freqSel->imax = (long)((freqSel->freq+freqSel->band/2)/ freqSel->dnu) + 1;
 if (freqSel->imax > freqSel->nBin/2)  freqSel->imax = freqSel->nBin / 2;
 if (freqSel->imin < 0)                freqSel->imin = 0;

 if (freqSel->imin > freqSel->nBin/2)
    {UJError(3,"USfreqSelIni","frequency beyond simulation bandwidth");}
 
 freqSel->coef = 4. * freqSel->dt * freqSel->dnu / winNorm ;

 return;
}


/*------------------------------------------------ USfreqSelRead -----*/
void USfreqSelRead(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
 struct USfreqSel *freqSel;

 UJ_READ_HEADER_WITH_NAME(USfreqSel, freqSel);
 
 UJ_READ_LONG(freqSel->iClock)  
 UJ_READ_STRUCT(USignal, freqSel->input)
 UJ_READ_LONG(freqSel->nBinP2)
 UJ_READ_DOUBLE(freqSel->freq)
 UJ_READ_DOUBLE(freqSel->band)
  
 strcpy(bankName,freqSel->name);
 freqSel->out = USignalNew(strcat(bankName,".out"), iFile->ascii); 
    
 UJCObAdd(freqSel->iClock,freqSel,USfreqSelUJstructH,freqSel->name);
  
 return;
} 


/*------------------------------------------------- USfreqSelSim -----*/
void USfreqSelSim(freqSel,time)
struct USfreqSel *freqSel;
long time;
/*--------------------------------------------------------------------*/
{
 long j;

 freqSel->vect->dataD[freqSel->i] = freqSel->input->value * freqSel->window->dataD[freqSel->i];
 freqSel->i++;

 if (freqSel->i == freqSel->nBin)
    {
     freqSel->i = 0;
     UADfft(freqSel->vect,freqSel->nBinP2);
     freqSel->out->value=0;
     for (j=freqSel->imin; j<freqSel->imax; j++)
        {freqSel->out->value += freqSel->vect->dataD[2*j] * freqSel->vect->dataD[2*j]
	                      + freqSel->vect->dataD[2*j+1] * freqSel->vect->dataD[2*j+1];
        }

     freqSel->out->value = sqrt(freqSel->out->value*freqSel->coef);
    } 

 return;
}


/*----------------------------------------------------USgeneFree------*/
void USgeneFree(generator)
struct USgenerator *generator;
/*--------------------------------------------------------------------*/
{
 if (generator->name != NULL)  free(generator->name);

 USignalFree(generator->out);
 free(generator);
 return;
}


/*----------------------------------------------------- USgeneIni ----*/
void USgeneIni(generator, dt)
struct USgenerator *generator;
double dt;
/*--------------------------------------------------------------------*/
{ 
 if (generator == NULL)  UJError(3,"geneIni","no generator");
 
 generator->sigma      = generator->sigma / sqrt(dt);
 generator->out->value = 0.;
 return;
}


/*----------------------------------------------------- USgeneRead ----*/
void USgeneRead(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
 struct USgenerator *generator;

 UJ_READ_HEADER_WITH_NAME(USgenerator, generator)
 
 UJ_READ_LONG(generator->iClock)
 UJ_READ_DOUBLE(generator->sigma)

 strcpy(bankName,generator->name);
 generator->out = USignalNew(strcat(bankName,".out"), iFile->ascii);
 
 if (UJobH.debugLvl > 1)
    {fprintf(UJobH.fOut,"     clock=%ld  sigma=%f\n", generator->iClock, generator->sigma);}
    
 UJCObAdd(generator->iClock,generator,USgeneratorUJstructH,generator->name);
  
 return;
}
 

/*----------------------------------------------------- USgeneSim ----*/
void USgeneSim(generator, time)
struct USgenerator *generator;
long time;
/*--------------------------------------------------------------------*/
{
 double random;
  
 random                = UMrgausd(0);
 generator->out->value = generator->sigma * random;
 return;
}


/*------------------------------------------------------- USifIni ----*/
void USifIni(usif, dt)
struct USif *usif;
double dt;
/*--------------------------------------------------------------------*/
{ 
 if (usif == NULL)         UJError(3,"ifIni","no USif");
 if (usif->input == NULL)  UJError(3,"ifIni","no input signal");
 
 if      (strcmp(usif->condition, ">") == 0)  usif->type = 0;
 else if (strcmp(usif->condition, "<") == 0)  usif->type = 1;
 else
     {printf(" try tto use the condition %s\n",usif->condition);
      UJError(3,"USifIni"," Unknown condition ");
     }

 usif->out->value = 0.;

 return;
}


/*------------------------------------------------------ USifRead ----*/
void USifRead(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
 struct USif *usif;

 UJ_READ_HEADER_WITH_NAME(USif, usif)
 
 UJ_READ_LONG(usif->iClock)
 UJ_READ_STRUCT(USignal, usif->input)
 UJ_READ_S_CHAR(usif->condition)
 UJ_READ_DOUBLE(usif->value)
 UJ_READ_STRUCT(USignal, usif->yes)
 UJ_READ_STRUCT(USignal, usif->no)

 strcpy(bankName,usif->name);
 usif->out = USignalNew(strcat(bankName,".out"), iFile->ascii);
 
 UJCObAdd(usif->iClock,usif,USifUJstructH,usif->name);
  
 return;
}

 
/*--------------------------------------------------- USifSim ----*/
void USifSim(usif, time)
struct USif *usif;
long time;
/*--------------------------------------------------------------------*/
{
 if (usif->type == 0)                        /*--- case input > value ---*/
    {if (usif->input->value > usif->value)
        {if (usif->yes != NULL)  usif->out->value = usif->yes->value;
         else                    usif->out->value = 0.;
        }
     else
        {if (usif->no != NULL)   usif->out->value = usif->no->value;
         else                    usif->out->value = 0.;
        }
    }
 else                                        /*--- case input < value ---*/
    {if (usif->input->value < usif->value)
        {if (usif->yes != NULL)  usif->out->value = usif->yes->value;
         else                    usif->out->value = 0.;
        }
      else
        {if (usif->no != NULL)   usif->out->value = usif->no->value;
         else                    usif->out->value = 0.;
        }
     }

 return;
}


/*------------------------------------------------------- USifMIni ----*/
void USifMIni(usifM, dt)
struct USifM *usifM;
double dt;
/*--------------------------------------------------------------------*/
{
 if (usifM == NULL)  UJError(3,"ifIni","no USifM");	 
   
 usifM->Test       = USifMreads( usifM->stringtest);
 usifM->out->value = 0.;

 return;
}


/*------------------------------------------------------- USifMstrcount ----*/
int USifMstrcount(p,t)
char *p;
int t;
/*--------------------------------------------------------------------*/
{ 
 char *s;
 int i; 

 s = p;
 i = 0;

 while (*s != '\0')
    {if (*s == (char)t) i++;
     s++;
    }

 return i;
}


/*--------------------------------------------------- USifMstrchr ----*/
char *USifMstrchr(p,t)
char *p;
int t;
/*--------------------------------------------------------------------*/
{ 
 char *s;
 int i;
 
 s = p + strlen(p);
 i = 0;
 
 while (s > p  &&  !(*s == (char)t  &&  i == 0) )
    {
     if (*s == '(') i++;
     if (*s == ')') i--; 
     s--;
    }

 if (s == p)  return(NULL);
 else         return(s);
}


/*------------------------------------------------- USifMcutparen ----*/
int USifMcutparen(p)
char *p;
/*--------------------------------------------------------------------*/
{
 char *s;
 int i,len;

 s   = p + 1;
 len = strlen(p);
 i   = 0;

 if (*p == '(')
    {i = 1;
     while (*s != '\0'  &&  i > 0)
	{if (*s == '(') i++;
         if (*s == ')') i--; 
	 s++;
        }
     if (s == p+len  &&  *(p+len-1) == ')') 
        {strncpy(p,p+1,len-2);
         *(p+len-2) = '\0';
         return(1);
        }
    }

 return(0);
}



/*------------------------------------------------- USifMreads ----*/
struct USifMtest *USifMreads(s)
char *s;
/*-----------------------------------------------------------------*/
{
 struct USifMtest *test;
 char *c,*b,*bb,*mes;
 char *ope="&|><-+*/";
 int i; 

 /*--- remove paren ---*/

 while (USifMcutparen(s));

 if (strlen(s) == 0)  UJError(3,"USifreads"," syntax error");

 test = (struct USifMtest *)calloc(1,sizeof(struct USifMtest)); 

 c    = NULL;
 i    = 0;

 /*--- search a operator in string ---*/

 while((c=USifMstrchr(s, ope[i])) == NULL  &&  i<strlen(ope)) i++;

 if (i < strlen(ope)) 
    {/*--- find a operator -> split the string in two part ---*/
     b         = (char *)calloc(strlen(s)+1,sizeof(char));
     bb        = (char *)calloc(strlen(s)+1,sizeof(char));
     test->ope = ope[i];

     /*--- replace string "-5" -> "0.-5" ---*/
     if (c == s  &&  (test->ope == '+'  ||  test->ope == '-')) 
	{test->left = USifMreads("0.");}
     else 
	{test->left = USifMreads(strncpy(b,s,strlen(s)-strlen(c)));}

     test->right = USifMreads(strcpy(bb,++c)); 
      
     free(b);
     free(bb);	
    }

 else 
    {/*--- no operator -> read number or USignal ---*/
     test->ope   = 0;
     test->input = (struct USignal *)calloc(1,sizeof(struct USignal));
     if (isalpha(s[0]))
        {if ((test->input = USignalFind(s)) == NULL)
            {mes = (char *)calloc(40,sizeof(char));
             sprintf(mes,"USignal &%s not created",s);
             UJError(3,"USifreads",mes);
            }
        }
     else 
        {test->input->value = atof(s);}
    }

 return(test);
}


/*------------------------------------------------- USifMEval ----*/
void USifMFreetest(test)
struct USifMtest *test;
/*----------------------------------------------------------------*/
{ 
 if (test->right != NULL)  USifMFreetest(test->right);
 if (test->left  != NULL)  USifMFreetest(test->left);
 if (test->input != NULL)  USignalFree(test->input);

 free(test);
 return;
}


/*------------------------------------------------- USifMEval ----*/
double USifMEval(test)
struct USifMtest *test;
/*----------------------------------------------------------------*/
{ 
 switch (test->ope)
   {
    case '*': 
       {return (USifMEval(test->right)*USifMEval(test->left)); 
        break;
       } 
    case '/': 
       {return (USifMEval(test->left)/USifMEval(test->right)); 
        break;
       } 
    case '+': 
       {return (USifMEval(test->left)+USifMEval(test->right)); 
        break;
       }
    case '-': 
       {return (USifMEval(test->left)-USifMEval(test->right)); 
        break;
       }
    case '&': 
       {return ((int)USifMEval(test->right) && (int)USifMEval(test->left)); 
        break;
       }
    case '|': 
       {return ((int)USifMEval(test->right) || (int)USifMEval(test->left)); 
        break;
       }
    case '>':         /*--- case input > value ---*/
       {if(USifMEval(test->left) > USifMEval(test->right)) return(1.);
        break;
       }
    case '<':         /*--- case input < value ---*/
       {if(USifMEval(test->left) < USifMEval(test->right)) return(1.);
        break;
       }
    case 0:
       {return(test->input->value);}
   }

 return 0.;
}


/*------------------------------------------------------ USifMRead ----*/
void USifMRead(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
 struct USifM *usifM;
 char *bank; 

 UJ_READ_HEADER_WITH_NAME(USifM, usifM)
 
 UJ_READ_LONG(usifM->iClock)
 
 usifM->stringtest = calloc(256,sizeof(char));

 do {
     UJ_READ_S_CHAR(bank)
     strcat(usifM->stringtest,bank);
    }
 while (USifMstrcount(usifM->stringtest,'(') > USifMstrcount(usifM->stringtest,')'));

 if (USifMstrcount(usifM->stringtest,')') > USifMstrcount(usifM->stringtest,'('))
    {UJError(3,"USifMRead"," syntax error");}

 UJ_READ_STRUCT (USignal, usifM->yes)
 UJ_READ_STRUCT (USignal, usifM->no)

 strcpy(bankName,usifM->name);
 usifM->out = USignalNew(strcat(bankName,".out"), iFile->ascii);

 UJCObAdd(usifM->iClock,usifM,USifMUJstructH,usifM->name);

 return;
}


/*------------------------------------------------- USifMFree ------*/
void USifMFree(usifM)
struct USifM *usifM;
/*-----------------------------------------------------------------*/
{
 if (usifM->stringtest != NULL)  free(usifM->stringtest);

 USifMFreetest(usifM->Test);
 USignalFree(usifM->out);
 free(usifM);
 return;
}
 

/*--------------------------------------------------- USifMSim ----*/
void USifMSim(usifM, time)
struct USifM *usifM;
long time;
/*--------------------------------------------------------------------*/
{
 double res;

 res = USifMEval(usifM->Test);

 if ((int)res == 1)
    {if (usifM->yes != NULL)  usifM->out->value = usifM->yes->value;
     else                     usifM->out->value = 0.;
    }
 else
    {if (usifM->no != NULL)   usifM->out->value = usifM->no->value;
     else                     usifM->out->value = 0.;
    }

 return;
}


/*----------------------------------------------------- USignalFind ----*/
struct USignal *USignalFind(name)
char *name;
/*--------------------------------------------------------------------*/
{
 struct USignal *USignal;

 USignal = USfirstSignal;
  
 while(USignal != NULL)
    {if (strcmp(name,USignal->name) == 0)  return(USignal);
     USignal = USignal->next;
    }

 return(NULL);
}


/*---------------------------------------------------USignalEnd------*/
void USignalEnd()
/*--------------------------------------------------------------------*/
{
 struct USignal *signal, *signalI;

 signal = USfirstSignal;
 
 while (signal != NULL) 
   {
    signalI = signal->next;
    if (signal->name != NULL)  free(signal->name);
    free(signal);
    signal = signalI;
   }

 USfirstSignal = NULL; 
 return;
}


/*---------------------------------------------------USignalFree------*/
void USignalFree(signal)
struct USignal *signal;
/*--------------------------------------------------------------------*/
{
 struct USignal *last;

 if (USfirstSignal == signal)
    {USfirstSignal = signal->next;}
 else
    {last = USfirstSignal;
     while (last->next != signal) 
        {last = last->next;
         if (last == NULL)  UJError(3,"USignalFree","corrupted chain");
        }
     last->next = signal->next;
    }
     
 if (signal->name != NULL)  free(signal->name);

 free(signal);
 return;
}


/*----------------------------------------------------- USignalNew ----*/
struct USignal *USignalNew(name, ascii)
char *name;
BOOL ascii;
/*--------------------------------------------------------------------*/
{
 struct USignal *USignal, *last;

 USignal = (struct USignal *)malloc(sizeof(struct USignal));
 if (USignal == NULL)  UJError(3,"USignalNew","malloc USignal failed"); 

 USignal->name = malloc(strlen(name)+1);
 if (USignal->name == NULL)   UJError(3,"USignalNew","malloc name failed");
 strcpy(USignal->name,name);

 if      (ascii == YES)  {UJSetBA( name,"USignal",             USignal);} 
 else if (ascii == NO)   {UJSetBAT(  -1, USignalUJstructH->id, USignal);}

 USignal->next  = NULL;
 USignal->value = 0.;
   
 if (USfirstSignal == NULL)
    {USfirstSignal = USignal;}
 else
    {last = USfirstSignal;
     while (last->next != NULL)  last = last->next;
     last->next = USignal;
    }
     
 return(USignal);
} 


/*----------------------------------------------------- USignalRead ----*/
void USignalRead(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
 struct USignal *signal, *last;

 UJ_READ_HEADER_WITH_NAME(USignal, signal)
 
 UJ_READ_DOUBLE(signal->value)

 signal->next = NULL;

 if (USfirstSignal == NULL)
    {USfirstSignal = signal;}
 else
    {last = USfirstSignal;
     while (last->next != NULL)  last = last->next;
     last->next = signal;
    }
     
 return;
}

 
/*--------------------------------------------------- USignal6New ----*/
struct USignal6 *USignal6New(name, ascii)
char *name;
BOOL ascii;
/*--------------------------------------------------------------------*/
{
 struct USignal6 *s6, *last;

 s6 = (struct USignal6*)malloc(sizeof(struct USignal6));
 if (s6 == NULL)  UJError(3,"USignal6New","malloc USignal6 failed"); 

 s6->name = malloc(strlen(name)+1);
 if (s6->name == NULL) UJError(3,"USignal6New","malloc name failed");
 strcpy(s6->name,name);

 if      (ascii == YES)  {UJSetBA( name,"USignal6",             s6);} 
 else if (ascii == NO)   {UJSetBAT(  -1, USignal6UJstructH->id, s6);}

 s6->next = NULL;
   
 if (USfirstSignal6 == NULL)
    {USfirstSignal6 = s6;}
 else
    {last = USfirstSignal6;
     while (last->next != NULL)  last = last->next;
     last->next = s6;
    }
     
 s6->s[0] = USignalNew (strcat(strcpy(bankName,s6->name),".s0"), ascii);
 s6->s[1] = USignalNew (strcat(strcpy(bankName,s6->name),".s1"), ascii);
 s6->s[2] = USignalNew (strcat(strcpy(bankName,s6->name),".s2"), ascii);
 s6->s[3] = USignalNew (strcat(strcpy(bankName,s6->name),".s3"), ascii);
 s6->s[4] = USignalNew (strcat(strcpy(bankName,s6->name),".s4"), ascii);
 s6->s[5] = USignalNew (strcat(strcpy(bankName,s6->name),".s5"), ascii);

 return(s6);
} 


/*-------------------------------------------------- USignal6Find ----*/
struct USignal6 *USignal6Find(name)
char *name;
/*--------------------------------------------------------------------*/
{
 struct USignal6 *s6;

 s6 = USfirstSignal6;
  
 while (s6 != NULL)
    {if (strcmp(name,s6->name) == 0) return (s6);
     s6 = s6->next;
    }

 return(NULL);
}


/*--------------------------------------------------USignal6Free------*/
void USignal6Free(s6)
struct USignal6 *s6;
/*--------------------------------------------------------------------*/
{
 struct USignal6 *last;

 if (USfirstSignal6 == s6)
    {USfirstSignal6 = s6->next;}
 else
    {last = USfirstSignal6;
     while (last->next != s6) 
        {last = last->next;
         if (last == NULL)  UJError(3,"USignal6Free","corrupted chain");
        }
     last->next = s6->next;
    }
     
 if (s6->name != NULL)  free(s6->name);

 free(s6);
 return;
}


/*---------------------------------------------------- US6SetFree ---*/
void US6SetFree(set6)
struct US6Set *set6;
/*--------------------------------------------------------------------*/
{
 if (set6->name != NULL)  free(set6->name);

 USignal6Free(set6->out);
 free(set6);
 return;
}


/*--------------------------------------------------- US6SetRead -*/
void US6SetRead(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
 struct US6Set *set6;
 long i;
 
 UJ_READ_HEADER_WITH_NAME(US6Set, set6);

 UJ_READ_LONG(set6->iClock);
 for (i=0; i<6; i++)
    {UJ_READ_STRUCT(USignal, set6->in[i]);}

 if (UJobH.debugLvl > 0)
    {fprintf(UJobH.fOut," \n Read bank US6Set %s (%p):\n",bankName,set6);}
  
 UJCObAdd(set6->iClock, set6, US6SetUJstructH,set6->name);

 set6->out = USignal6New (strcat(strcpy(bankName,set6->name),".out"), iFile->ascii);
   
 return;
}

 
/*------------------------------------------------------ US6SetSim-*/
void US6SetSim(set6, time)         
struct US6Set *set6;
long time;
/*--------------------------------------------------------------------*/
{
 long i;

 if (set6 == NULL) return;

 for (i=0; i<6; i++)
    {if (set6->in[i] == NULL) continue;
     set6->out->s[i]->value = set6->in[i]->value;
    }
 
 return;
}
 
 
/*------------------------------------------------- US6SmearFree ---*/
void US6SmearFree(position)
struct US6Smear *position;
/*--------------------------------------------------------------------*/
{
 if (position->name != NULL)  free(position->name);
 free(position);
 return;
}


/*------------------------------------------------ US6SmearIni -----*/
void US6SmearIni(position, dt)
struct US6Smear *position;
double dt;
/*--------------------------------------------------------------------*/
{
 long i;

 if (position == NULL) return;
  
 for (i=0; i<6; i++)
    {position->rms[i]           = position->rms[i] * sqrt(dt);
     position->out->s[i]->value = 0;
    }
  
 return;
}

 
/*--------------------------------------------------- US6SmearRead -*/
void US6SmearRead(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
 struct US6Smear *position;
 long i;
 
 UJ_READ_HEADER_WITH_NAME(US6Smear, position);

 UJ_READ_LONG(position->iClock);
 UJ_READ_STRUCT(USignal6, position->in);
 for (i=0; i<6; i++)
    {UJ_READ_DOUBLE(position->rms[i]);}

 if (UJobH.debugLvl > 0)
    {fprintf(UJobH.fOut," \n Read bank US6Smear %s (%p):\n",bankName,position);}
  
 UJCObAdd(position->iClock, position, US6SmearUJstructH,position->name);

 position->out = USignal6New (strcat(strcpy(bankName,position->name),".out"), iFile->ascii);
   
 return;
}

 
/*------------------------------------------------------ US6SmearSim-*/
void US6SmearSim(position, time)         /* Compute MIrror's motion */
struct US6Smear *position;
long time;
/*--------------------------------------------------------------------*/
{
 long i;

 if (position == NULL) return;

 for (i=0; i<6; i++)
    {position->out->s[i]->value = position->in->s[i]->value + position->rms[i]* UMrgausd(0);}
 
 return;
}

 
/*--------------------------------------------------USsweepFree------*/
void USsweepFree(sweep)
struct USsweep *sweep;
/*--------------------------------------------------------------------*/
{
 if (sweep->name != NULL)  free(sweep->name);

 USignalFree(sweep->out);
 free(sweep);
 return;
}


/*--------------------------------------------------- USsweepIni ----*/
void USsweepIni(sweep, dt)
struct USsweep *sweep;
double dt;
/*--------------------------------------------------------------------*/
{ 
 if (sweep == NULL)  UJError(3,"sweepIni","no sweep");
 
 sweep->step       = dt * sweep->slope;
 sweep->out->value = sweep->start;

 return;
}


/*-------------------------------------------------- USsweepRead ----*/
void USsweepRead(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
 struct USsweep *sweep;

 UJ_READ_HEADER_WITH_NAME(USsweep, sweep)
 
 UJ_READ_LONG(sweep->iClock)
 UJ_READ_DOUBLE(sweep->start)
 UJ_READ_DOUBLE(sweep->slope)

 strcpy(bankName,sweep->name);
 sweep->out = USignalNew(strcat(bankName,".out"), iFile->ascii);
 
 UJCObAdd(sweep->iClock,sweep,USsweepUJstructH,sweep->name);
  
 return;
}

 
/*--------------------------------------------------- USsweepSim ----*/
void USsweepSim(sweep, time)
struct USsweep *sweep;
long time;
/*--------------------------------------------------------------------*/
{ 
 sweep->out->value = sweep->out->value + sweep->step;
 return;
}


/*--------------------------------------------------UStransFRead----*/
void UStransFRead(iFile)
struct UJfile *iFile;
/*----------------------------------------------------------------*/
{
 struct UStransF *transF;
 long i;

 UJ_READ_HEADER_WITHOUT_NAME(UStransF,transF);
 UJ_READ_LONG(transF->iClock);
 UJ_READ_LONG(transF->id);
 if (!transF->nameModulus) transF->nameModulus = (char *) calloc(15,sizeof(char));
 sprintf(transF->nameModulus,"hTFM%d",transF->id);
 if (!transF->namePhase) transF->namePhase = (char *) calloc(15,sizeof(char));
 sprintf(transF->namePhase,"hTFM%ld",transF->id);
 UJ_READ_LONG(transF->nBin);
 UJ_READ_DOUBLE(transF->numin);
 UJ_READ_DOUBLE(transF->numax);

 UJ_READ_LONG(transF->nNum);
 transF->degnum   = transF->nNum - 1;
 transF->aReverse = (double*)malloc(sizeof(double)*(transF->nNum));
 transF->a        = (double*)malloc(sizeof(double)*(transF->nNum));
 if (transF->aReverse == NULL  ||  transF->a == NULL)  UJError(3,"transFRead","malloc failed");

 for (i=0; i<transF->nNum; i++)
    {UJ_READ_DOUBLE(transF->aReverse[i]);
     transF->a[transF->degnum-i] = transF->aReverse[i];
    }

 UJ_READ_LONG(transF->nDen);
 transF->degden   = transF->nDen-1;
 transF->bReverse = (double*)malloc(sizeof(double)*(transF->nDen));
 transF->b        = (double*)malloc(sizeof(double)*(transF->nDen));
 if (transF->bReverse == NULL  ||  transF->b == NULL)  UJError(3,"transFRead","malloc failed");

 for (i=0; i<transF->nDen; i++)
    {UJ_READ_DOUBLE(transF->bReverse[i]);
     transF->b[transF->degden-i] = transF->bReverse[i];
    }

 UJCObAdd(transF->iClock,transF,UStransFUJstructH,NULL);

 return;
}


/*----------------------------------------------------- UStransFEnd ---*/
void UStransFEnd(transF)
struct UStransF *transF;
/*--------------------------------------------------------------------*/
{
 double dnu, numinlog, numaxlog, dnulog, klog;
 double ren, imn, red, imd;
 double omega, nu, modulus, phase, phi, old;
 long i, n;

 dnu      = (transF->numax - transF->numin) / (double)transF->nBin;
 numinlog = log10(transF->numin);
 numaxlog = log10(transF->numax);
 dnulog   = (numaxlog - numinlog) / (double)transF->nBin;

 RA_H1New(transF->nameModulus ,"Transfer Function Modulus",transF->nBin,numinlog,numaxlog);
 RA_H1New(transF->namePhase ,"Transfer Function Phase",transF->nBin,numinlog,numaxlog);

 n   = 0;
 old = -PI;
 for (klog = numinlog + dnulog/2.; klog < numaxlog+dnulog/2.; klog = klog + dnulog) 
    {nu    = pow(10.,klog);
     omega = 2.*PI * nu;

     ren = 0.;
     for (i=0; 2*i<=transF->degnum; i++)
        {ren += pow(-1.,(double)i) * transF->a[2*i] *pow(omega,(double)(2*i));}
     imn = 0.;
     for (i=0; 2*i+1 <= transF->degnum; i++)
        {imn += pow(-1.,(double)i) * transF->a[2*i+1] * pow(omega,(double)(2*i+1));}

     red = 0.;
     for (i=0; 2*i <= transF->degden; i++)
        {red += pow(-1.,(double)i) * transF->b[2*i] * pow(omega,(double)(2*i));}
     imd = 0.;
     for (i=0; 2*i+1 <= transF->degden; i++)
        {imd += pow(-1.,(double)i) * transF->b[2*i+1] * pow(omega,(double)(2*i+1));}

     modulus = sqrt((ren*ren + imn*imn)/(red*red + imd*imd));
     phi     = atan2((imn*red - ren*imd), (ren*red + imn*imd));
     phase   = phi - n * TWOPI;
     if (fabs(phase-old-TWOPI) < 0.5) n++;
     if (fabs(old-phase-TWOPI) < 0.5) n--;
     phase   = phi - n * TWOPI;
     old     = phase;
     RA_H1Fill(transF->nameModulus, klog ,modulus);
     RA_H1Fill(transF->namePhase, klog ,phase);
    }

 return;
}

/*------------------------------------------------------ USburgRead ---*/
void USburgRead(iFile)
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
  struct USburg *burg;

  UJ_READ_HEADER_WITH_NAME(USburg, burg);

  UJ_READ_LONG(burg->iClock)
  UJ_READ_STRUCT(USignal, burg->input)
  UJ_READ_LONG(burg->nData);
  UJ_READ_LONG(burg->pNum);
  
  strcpy(bankName,burg->name);
  burg->out = USignalNew(strcat(bankName,".out"), iFile->ascii); 

  UJCObAdd(burg->iClock,burg,USburgUJstructH,burg->name);

  if(burg->nData <= burg->pNum)
    UJError(3,"USburgRead","data buffer shorter than AR coefficients number");
  return;
}

/*------------------------------------------------------ USburgIni ----*/
void USburgIni(burg, dt)
struct USburg *burg;
double dt;
/*--------------------------------------------------------------------*/
{
  /* buffers */
  burg->a         = (double*) malloc(sizeof(double)*burg->pNum);
  burg->inputData = (double*) malloc(sizeof(double)*burg->nData);

  if(burg->a == NULL || burg->inputData == NULL)
    UJError(3,"USburgIni","failed to allocate memory buffer");

  /* defaults */
  burg->nDataRead = 0;
  burg->pUsed     = 0;

  return;}

/*------------------------------------------------------ USburgSim ----*/
void USburgSim(burg, time)  
struct USburg *burg;
long time;
/*--------------------------------------------------------------------*/
{ 
#define SQR(a) ( (a) == 0.0 ? 0.0 : (a) * (a) )
  long k,j,i;
  long m, n;
  double ris;
  double p, *wk1, *wk2, *wkm;
  double *data, *xms, *a;
  
  /* we still have to read the buffer */
  if(burg->nDataRead < burg->nData)
    {
      /* fill the buffer */
      burg->inputData[burg->nDataRead] = burg->input->value;
      burg->nDataRead++;

      /* update the output */
      burg->out->value = burg->input->value;
      return;
    }
  /* we have read the buffer, find filter coefficients */
  if(burg->pUsed == 0)
    {
      p = 0.0;
      /* buffer allocation */
      wk1 = (double*) malloc(sizeof(double)*burg->nData);
      wk2 = (double*) malloc(sizeof(double)*burg->nData);
      wkm = (double*) malloc(sizeof(double)*burg->pNum);
      if(wk1 == NULL || wk2 == NULL || wkm == NULL)
	UJError(3,"UJburgSim","unable to allocate buffers");

      /* pointer shifts */
      wk1 = wk1 - 1;
      wk2 = wk2 - 1;
      wkm = wkm - 1;
      
      xms  = &(burg->sigma);
      m    = burg->pNum;
      n    = burg->nData;
      data = burg->inputData - 1;
      a    = burg->a - 1;

      for (j=1;j<=n;j++) p += SQR(data[j]);
      *xms=p/n;
      wk1[1]=data[1];
      wk2[n-1]=data[n];
      for (j=2;j<=n-1;j++)
	{
	  wk1[j]=data[j];
	  wk2[j-1]=data[j];
	}
      for (k=1;k<=m;k++)
	{
	  double num=0.0,denom=0.0;
	  for (j=1;j<=(n-k);j++)
	    {
	      num   += wk1[j]*wk2[j];
	      denom += SQR(wk1[j]) + SQR(wk2[j]);
	    }
	  a[k]=2.0*num/denom;
	  *xms *= (1.0-SQR(a[k]));
	  for (i=1;i<=(k-1);i++)
	    a[i]=wkm[i]-a[k]*wkm[k-i];

	  if (k == m)
	    {
	      /* buffer deallocation */
	      free(wk1 + 1);
	      free(wk2 + 1);
	      free(wkm + 1);
	      
	      /* update the variance */
	      *xms = sqrt(*xms);
	      
	      /* set the number of coefficients used */
	      burg->pUsed = m;
	      
	      /* the next time we shall use the coefficients */
	      burg->out->value = burg->input->value;
	      return;
	    }
	  for (i=1;i<=k;i++) wkm[i]=a[i];
	  for (j=1;j<=(n-k-1);j++)
	    {
	      wk1[j] -= wkm[k]*wk2[j];
	      wk2[j]=wk2[j+1]-wkm[k]*wk1[j+1];
	    }
	}
      UJError(3,"UJburgSim","never get here!");
    }
  /* we have the coefficients, use them */

  data = burg->inputData - 1;
  a    = burg->a - 1;

  /* make room for the new element in the buffer (only the needed ones) */
  /* memmove((void*) &(data[burg->nData - burg->pUsed]),
     (const void*) &(data[burg->nData - burg->pUsed + 1]),
     (size_t) sizeof(double)*burg->pUsed); */
  for(i = (burg->nData - burg->pUsed); i<burg->nData; i++)
    data[i] = data[i+1];
  
  /* insert new element */
  ris = data[burg->nData] = burg->input->value;

  /* regress to find the output value */
  for(i=1; i<=burg->pUsed;i++)
    {
      ris -= data[burg->nData - i] * a[i];
    }
  burg->out->value = ris;
  return;}


/*----------------------------------------------------- USburgFree ---*/
void USburgFree(burg)
struct USburg *burg;
/*--------------------------------------------------------------------*/
{
  free(burg->a);
  free(burg->inputData);
}

/*----------------------------------------------------- USburgEnd ---*/
void USburgEnd(burg)
struct USburg *burg;
/*--------------------------------------------------------------------*/
{
  return;
}

/*----------------------------------------------------- USimpulseFree --*/
void USimpulseFree(impulse)
struct USimpulse *impulse;
/*--------------------------------------------------------------------*/
{
  globfree(&(impulse->pglob));
}

/*----------------------------------------------------- USimpulseIni--*/
void USimpulseIni(impulse, dt)
struct USimpulse *impulse;
double dt;
/*--------------------------------------------------------------------*/
{
  char err;
  long len;
  int flags = 0;
  struct stat statbuf;
  char buffer[256];

  /* init status */
  impulse->file    = NULL;
  impulse->fileNum = 0;

  /* init frequency in units of ticks: define the average mu over
     the single tick so that (mu*N) = 1, where N is the number of 
     ticks corresponding to the inverse of the frequency */
  impulse->mu = impulse->frequency*dt;

  /* check the given pattern with a bit of heuristics */
  len = strlen(impulse->pattern);
  if(!strstr(impulse->pattern,"*")) /* it is not a pattern: inquire */
    {
      /* inquire if it makes sense */
      err = stat(impulse->pattern, &statbuf);
      if(err == -1)
	{
	  sprintf(buffer,
		  "pattern %s is not a file or a directory",
		  impulse->pattern);
	  UJError(3,"USimpulseIni",buffer);
	}
      /* check what it is */
      if(S_ISDIR(statbuf.st_mode))
	{
	  /* OK, append "start of comment" */
	  sprintf(buffer,"%s/*",impulse->pattern);
	}
      else if(S_ISREG(statbuf.st_mode))
	{
	  /* OK as it is */
	  sprintf(buffer,"%s",impulse->pattern);
	}
      else
	{
	  sprintf(buffer,"%s is not a file or a directory", 
		  impulse->pattern);
	  UJError(3,"USimpulseIni",buffer);
	}
    }
  else /* it is a pattern, leave it as it is */
    sprintf(buffer,"%s",impulse->pattern);

  /* scan the directory containing the data */
  if(glob(buffer, flags, NULL, &(impulse->pglob)))
     {
       sprintf(buffer,"the pattern %s does not expand to useful files",
	       impulse->pattern);
       UJError(3,"USimpulseIni",buffer);
     }

  if(impulse->pglob.gl_pathc == 0)
    {
      sprintf(buffer,"no files found with pattern %s",
	      impulse->pattern);
      UJError(3,"USimpulseIni",buffer);
    }

  sprintf(buffer,"%ld file entries found",
	  impulse->pglob.gl_pathc);
  UJError(1,"USimpulseIni",buffer);

  return;
}
 

/*----------------------------------------------------- USimpulseRead--*/
void USimpulseRead(iFile)                       /* read impulse bank   */
struct UJfile *iFile;
/*--------------------------------------------------------------------*/
{
  long i;
  struct USimpulse *impulse;

  UJ_READ_HEADER_WITH_NAME(USimpulse, impulse);
  
  UJ_READ_LONG(impulse->iClock);
  UJ_READ_DOUBLE(impulse->frequency);
  UJ_READ_DOUBLE(impulse->scale);
  UJ_READ_LONG(impulse->nSignal);
  UJ_READ_S_CHAR(impulse->pattern);
    
  UJCObAdd(impulse->iClock, impulse, USimpulseUJstructH, impulse->name);
  
  if(impulse->nSignal == 0)
    UJError(3,"USimpulseRead", "you asked to read 0 columns");
  
  impulse->out = 
    (struct USignal **) malloc(sizeof(struct USignal*)*
			       impulse->nSignal);
  if(impulse->out == NULL)
    UJError(3,"USimpulseRead","unable to allocate output channels");

  for(i=0; i<impulse->nSignal; i++)
    {
      sprintf(bankName,"%s.out%ld",impulse->name,i);
      impulse->out[i] = USignalNew(bankName, iFile->ascii);
    }

 return;
}

/*---------------------------------------------------USimpulseTrigger --*/
long USimpulseTrigger(max, dim) /* Trigger the start */
double max;
long dim;
/*---------------------------------------------------------------------*/
{
  long reject = 1;
  double p;
  double ran;
  double scale;

  while(reject)
    {
      /* generate a random number in the chosen interval */
      scale = max*UMrandom(0);

      /* generate the value of the distribution */
      p = dim*pow(scale,dim-1)/pow(max,dim);
      
      /* generate another random number and check if p is smaller */
      ran = (((double) dim)/max)*UMrandom(0);

      if(ran < p)
	reject = 0;
    }
  return scale;
}

/*----------------------------------------------------USimpulseSim -----*/
void USimpulseSim(impulse, time)         /* Generate the impulse signal */
struct USimpulse *impulse;
long time;
/*---------------------------------------------------------------------*/
{
  long i;
  char err;
  double tmp;
  char buffer[128];

  if(impulse->file == NULL) /* no file is being read */
    {
      /* is there any file to read? */
      if(impulse->fileNum < impulse->pglob.gl_pathc)
	if(UMrandom(0) < impulse->mu) /* time to read an impulse */
	  {
	    impulse->file = 
	      fopen(impulse->pglob.gl_pathv[impulse->fileNum], "r");
	    if(impulse->file == NULL)
	      {
		sprintf(buffer,"unable to open %s for reading",
			impulse->pglob.gl_pathv[impulse->fileNum]);
		UJError(2,"USimpulseSim",buffer);
	      }
	    else
	      {
		/* inform the happy user */
		sprintf(buffer,"start new impulse read from %s",
			impulse->pglob.gl_pathv[impulse->fileNum]);
		UJError(1,"USimpulseSim",buffer);
	      }
	    impulse->fileNum++;
	  }
    }

  /* set to zero preliminarly */
  for(i=0; i<impulse->nSignal; i++)
    impulse->out[i]->value = 0.0;
  
  /* then read */
  if(impulse->file != NULL)
    for(i=0; i<impulse->nSignal; i++)
      {
	err = fscanf(impulse->file,"%le",&tmp);
	if(err == EOF)
	  {
	    /* close and reset impulse->file, which serves also as flag */
	    fclose(impulse->file);
	    impulse->file = NULL;
	    break;
	  }
	else
	  impulse->out[i]->value = impulse->scale * tmp;
      }
  return;
}

/*----------------------------------------------------- USimpulseEnd ---*/
void USimpulseEnd(impulse)
struct USimpulse *impulse;
/*--------------------------------------------------------------------*/
{
  if(impulse->file != NULL)
    UJError(2,"USimpulseEnd","impulse truncated by simulation's end");

  return;
}


/*----------------------------------------------------USimpulseRandom --*/
double USimpulseScale(maxDist) /* Generate a random distance */
double maxDist;
/*---------------------------------------------------------------------*/
{
  long reject = 1;
  double p;
  double dist;
  double ran;

  while(reject)
    {
      /* generate a random number in the chosen interval */
      dist = maxDist*UMrandom(0);
      
      /* generate the value of the distribution */
      p = 3*pow(dist,2)/pow(maxDist,3);
      
      /* generate another random number and check if p is smaller */
      ran = (((double) 2)/maxDist)*UMrandom(0);

      if(ran < p)
	reject = 0;
    }
  return dist;
}

