// Original Author: Rene Brun   05/02/97
// Modified for use in VEGA and dataDisplay by D. Buskulic 13/05/03

#ifndef VEGA_VViewerSelector
#define VEGA_VViewerSelector


//////////////////////////////////////////////////////////////////////////
//                                                                      //
// VViewerSelector                                                      //
//                                                                      //
// A utility class for viewer data processing.                          //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


#ifndef ROOT_TObject
#include "TObject.h"
#endif
#ifndef ROOT_TString
#include "TString.h"
#endif
#include "FrameL.h"
#include "TClass.h"

class VViewerSelector : public TObject {
protected:
   Int_t     mStatus;  //Selector status
   TString   mOption;  //option given to VFrameChannel::Process
   TObject  *mObject;  //current object if processing object (vs. VFrameChannel)

public:
   VViewerSelector();
   virtual            ~VViewerSelector();
   virtual void        Init() { }
   virtual void        Begin() { }
//   virtual const char *GetOption() const { return mOption.Data();}
   virtual const char *GetOption() const;
   virtual Int_t       GetStatus() const {return mStatus;}
   virtual const char* GetViewerClassName() {return IsA()->GetName();}
   virtual Bool_t      ProcessCut(FrameH*) { return kTRUE; }
//   virtual Bool_t      ProcessFrame(FrameH*) { return kFALSE; }
   virtual Bool_t      ProcessVect(int, FrVect** , FrVect*, double* ) { return kFALSE; }
   virtual void        SetOption(const char *option) { mOption = option; }
   virtual void        SetObject(TObject *obj) { mObject = obj; }
   virtual void        SetStatus(Int_t status) { mStatus = status;}
   virtual void        Terminate() { }

   static  VViewerSelector  *GetSelector(const char *filename);

   ClassDef(VViewerSelector,0)  //A utility class for viewer data processing
};

#endif
