#define LowPassFilter_cxx
// The class definition in LowPassFilter.h has been generated automatically
// by the Data Display utility MakeClass().
//
// This class is derived from the class VViewerSelector.
// The following members functions are called by the dataDisplay Process() functions:
//    Init():        called once per dataDisplay session
//    Begin():       called everytime a loop on the data starts,
//                   a convenient place to create your histograms.
//    ProcessVect(): called for each vector(s) that should be analyzed
//    Terminate():   called at the end of a loop in the dataDisplay,
//                   a convenient place to draw/fit your histograms.
//
#include "LowPassFilter.h"

#if !defined(__CINT__) || defined(__MAKECINT__)
// Here come the user includes like
// #include "TH1F.h"
#endif

void LowPassFilter::Init()
{
}


void LowPassFilter::Begin()
{
   // Function called before starting the analysis loop.
}

Bool_t LowPassFilter::ProcessVect(int nbvect, FrVect** invects, FrVect* outvect, double* par)
{
   // Function called for selected vectors only.
   // invects is an array of vectors, nbvect is the number.
   // of vectors in the array and outvect is the resulting.
   // output vector.
   // par is a set of parameters.
   // Return kFALSE to stop processing.

int i, j, ndata, nsum;
double sum, sum2;

ndata = invects[0]->nData;

if (par) nsum = (int)par[0];
else     nsum = 1;

if (buffer == NULL) buffer = (double *)calloc(nsum,sizeof(double));

sum = 0.;
for (j=0; j<nsum; j++)
   {
    sum += FrVectGetV (invects[0], j);
    outvect->dataD[j] = sum;
    for (i=j; i<nsum; i++) outvect->dataD[j] += buffer[i];
   }

sum2 = 0.;
for (j=nsum; j<ndata; j++)
   {
    sum  += FrVectGetV (invects[0], j);
    if (j>nsum) sum2 += FrVectGetV (invects[0], j-nsum-1);
    outvect->dataD[j] = sum - sum2;
   }

if (buffer)
   {for (i=0; i<nsum; i++) buffer[i] = FrVectGetV (invects[0], ndata-nsum+i);}

return kTRUE;
}

void LowPassFilter::Terminate()
{
   // Function called at the end of the analysis loop.
 if (buffer) free(buffer);

}
