#define MultVect_cxx
// The class definition in MultVect.h has been generated automatically
// by the Data Display utility MakeClass().
//
// This class is derived from the class VViewerSelector.
// The following members functions are called by the dataDisplay Process() functions:
//    Init():        called once per dataDisplay session
//    Begin():       called everytime a loop on the data starts,
//                   a convenient place to create your histograms.
//    ProcessVect(): called for each vector(s) that should be analyzed
//    Terminate():   called at the end of a loop in the dataDisplay,
//                   a convenient place to draw/fit your histograms.
//
#include "MultVect.h"

#if !defined(__CINT__) || defined(__MAKECINT__)
// Here come the user includes like
// #include "TH1F.h"
#endif

void MultVect::Init()
{
}


void MultVect::Begin()
{
   // Function called before starting the analysis loop.

}

Bool_t MultVect::ProcessVect(int nbvect, FrVect** invects, FrVect* outvect, double* par)
{
   // Function called for selected vectors only.
   // invects is an array of vectors, nbvect is the number.
   // of vectors in the array and outvect is the resulting.
   // output vector.
   // par is a set of parameters.
   // Return kFALSE to stop processing.

   unsigned int ndata_max;
   int i, j, indix;
   double value;

   ndata_max = 0;
   for (i=0; i<nbvect; i++)
      {if (invects[i])
          {if (ndata_max < invects[i]->nData) ndata_max = invects[i]->nData;}
      }

   for (j=0; j<ndata_max; j++)
      {
       outvect->dataD[j] = 1.;
       for (i=0; i<nbvect; i++)
          {
           if (invects[i])
              {indix = j * invects[i]->nData / ndata_max;
               value = FrVectGetV (invects[i], indix);
               if (par) outvect->dataD[j] *= value * par[i];
               else     outvect->dataD[j] *= value;
              }
          }
      }

   return kTRUE;
}

void MultVect::Terminate()
{
   // Function called at the end of the analysis loop.


}
