#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <stdarg.h>
#include <unistd.h>
#include <CmMessage.h>

#define LSTRING_MAX 256

int DyCmConnect ();
void DyUpdateCmList();
void DyCmSetCmDomain (char* DyCmDomain);
CmMessageStatus DyNamesHandler (CmMessage message, char* sender, char* serverName);

char CmDomain[256], CmName[256];


/*------------------------------------------------------ Main ---*/

int main (int argc, char *argv[])
{
 int k, i, ch;
 char *c;
 char *cmdomain[5] = {"Cascina","LAPP","LAL","Cascina","stop"};
 char *p, str[1], tmp;

 k = 0;
 strcpy(CmDomain,"Cascina");
 strcpy(CmName,"ddtest");

 while (strcmp(CmDomain,"stop") != 0)
    {
     printf("\nConnecting with CmDomain=%s \n",CmDomain);
sleep(5);
/**
     DyCmConnect();
**/
     DyUpdateCmList();

     printf("\n\n");
     k++;
     strcpy(CmDomain,cmdomain[k]);
/**
     strcpy(CmDomain,"");
     p = CmDomain;
     tmp = '.';
     while (tmp != '\n')
      {fscanf(stdin,"%c",&str);
       tmp = str[0];
       if (tmp != '\n') {printf("-%c- ",tmp); p += sprintf(p,"%c",tmp);}
      }
     printf("\n");
     printf("CmDomain=-%s-\n", CmDomain);
**/

    }


 return(0);
}


/*------------------------------------------ DyCmConnect ---*/

int DyCmConnect ()
{
 DyCmSetCmDomain(CmDomain);

 if (!CmMessageOpenServer(CmName))
     {printf("  Could not declare myself as Cm server with name %s \n", CmName);
      return(-1);
     }

 return(0);
}



/*------------------------------------------ DyUpdateCmList ---*/

void DyUpdateCmList()
{
 CmMessage message;
 CmConnectCondition condition;
 CmConnect server;
 char* destination, clientName[LSTRING_MAX];

 DyCmSetCmDomain (CmDomain);

 if (!CmMessageOpenMultipleServer("DyCmNamesAsker"))
    {printf("DyUpdateCmList: Cannot declare to Cm Name server \n");
     return;
    }

 strcpy(clientName,CmConnectGetName(CmConnectWhoAmI()));
 printf("DyUpdateCmList: my name is %s. Connected\n",clientName);

 CmMessageInstallHandler(DyNamesHandler,"NSNames");

 server      = CmConnectGetNameServer();
 destination = CmConnectGetName(server);

 message = CmMessageNew();
 CmMessageSetType(message, "NSGetNames");
 CmMessageSend(message, destination);
 CmMessageDelete(message);

 condition = CmMessageWaitWithTimeout(3.);

 if (condition == CmConnectTimeoutDetection)
    {printf("Timeout reached. I could not update the list of Cm servers.\n");}

 CmMessageUninstallHandler("NSNames");

 strcpy(clientName,CmConnectGetName(CmConnectWhoAmI()));
 CmMessageCloseServer(clientName);
 printf("DyUpdateCmList: my name was %s. Disconnected\n",clientName);

 return;
}


/*----------------------------------- DyCmSetCmDomain ---*/

void DyCmSetCmDomain (char* DyCmDomain)
{
 char cmdomain[LSTRING_MAX], dummy[LSTRING_MAX];

 if (DyCmDomain == NULL) return;

 CmConnectSetDomain(DyCmDomain);
 CmNameServerGetInfos();

 strcpy(cmdomain,getenv("CMDOMAIN"));
 if (strcmp(cmdomain, DyCmDomain) != 0) setenv("CMDOMAIN", DyCmDomain, 1);
 printf("******* cmdomain=%s  DyCmDomain=%s cmdomain_new=%s \n", cmdomain, DyCmDomain, getenv("CMDOMAIN"));

 return;
}


/*----------------------------------- DyNamesHandler ---*/

CmMessageStatus DyNamesHandler (CmMessage message, char* sender, char* serverName)
{
 const char *name;
 int ncm;

 printf("     Handler: CmDomain=%s\n",getenv("CMDOMAIN"));

 while (CmMessageGetItemType (message) == CmMessageItemText)
    {name = CmMessageGetText (message);
     if (strcmp(name,"<unknown>") == 0) continue;
     if (strcmp(name,serverName) == 0)  continue;
     if (strstr(name, "Users") != NULL) printf("%s ",name);
    }

 return (CmMessageBreak);
}



